// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_APPS_FOUNDATION_APP_SERVICE_PUBLIC_MOJOM_APP_REGISTRY_MOJOM_SHARED_H_
#define CHROME_BROWSER_APPS_FOUNDATION_APP_SERVICE_PUBLIC_MOJOM_APP_REGISTRY_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "chrome/browser/apps/foundation/app_service/public/mojom/app_registry.mojom-shared-internal.h"
#include "chrome/browser/apps/foundation/app_service/public/mojom/types.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace apps {
namespace mojom {


}  // namespace mojom
}  // namespace apps

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace apps {
namespace mojom {
// Interface base classes. They are used for type safety check.
class AppRegistryInterfaceBase {};

using AppRegistryPtrDataView =
    mojo::InterfacePtrDataView<AppRegistryInterfaceBase>;
using AppRegistryRequestDataView =
    mojo::InterfaceRequestDataView<AppRegistryInterfaceBase>;
using AppRegistryAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<AppRegistryInterfaceBase>;
using AppRegistryAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<AppRegistryInterfaceBase>;
class AppRegistry_GetApps_ParamsDataView {
 public:
  AppRegistry_GetApps_ParamsDataView() {}

  AppRegistry_GetApps_ParamsDataView(
      internal::AppRegistry_GetApps_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::AppRegistry_GetApps_Params_Data* data_ = nullptr;
};

class AppRegistry_GetApps_ResponseParamsDataView {
 public:
  AppRegistry_GetApps_ResponseParamsDataView() {}

  AppRegistry_GetApps_ResponseParamsDataView(
      internal::AppRegistry_GetApps_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAppInfosDataView(
      mojo::ArrayDataView<::apps::mojom::AppInfoDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAppInfos(UserType* output) {
    auto* pointer = data_->app_infos.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::apps::mojom::AppInfoDataView>>(
        pointer, output, context_);
  }
 private:
  internal::AppRegistry_GetApps_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AppRegistry_SetAppPreferred_ParamsDataView {
 public:
  AppRegistry_SetAppPreferred_ParamsDataView() {}

  AppRegistry_SetAppPreferred_ParamsDataView(
      internal::AppRegistry_SetAppPreferred_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAppIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAppId(UserType* output) {
    auto* pointer = data_->app_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadState(UserType* output) const {
    auto data_value = data_->state;
    return mojo::internal::Deserialize<::apps::mojom::AppPreferred>(
        data_value, output);
  }

  ::apps::mojom::AppPreferred state() const {
    return static_cast<::apps::mojom::AppPreferred>(data_->state);
  }
 private:
  internal::AppRegistry_SetAppPreferred_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace apps

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace apps {
namespace mojom {



inline void AppRegistry_GetApps_ResponseParamsDataView::GetAppInfosDataView(
    mojo::ArrayDataView<::apps::mojom::AppInfoDataView>* output) {
  auto pointer = data_->app_infos.Get();
  *output = mojo::ArrayDataView<::apps::mojom::AppInfoDataView>(pointer, context_);
}


inline void AppRegistry_SetAppPreferred_ParamsDataView::GetAppIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->app_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace apps

#endif  // CHROME_BROWSER_APPS_FOUNDATION_APP_SERVICE_PUBLIC_MOJOM_APP_REGISTRY_MOJOM_SHARED_H_
