// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "chrome/browser/apps/foundation/app_service/public/mojom/types.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/browser/apps/foundation/app_service/public/mojom/types.mojom-shared-message-ids.h"
namespace apps {
namespace mojom {
AppInfo::AppInfo()
    : id(),
      type(),
      preferred() {}

AppInfo::AppInfo(
    const std::string& id_in,
    AppType type_in,
    AppPreferred preferred_in)
    : id(std::move(id_in)),
      type(std::move(type_in)),
      preferred(std::move(preferred_in)) {}

AppInfo::~AppInfo() = default;
size_t AppInfo::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->id);
  seed = mojo::internal::Hash(seed, this->type);
  seed = mojo::internal::Hash(seed, this->preferred);
  return seed;
}

bool AppInfo::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace apps

namespace mojo {


// static
bool StructTraits<::apps::mojom::AppInfo::DataView, ::apps::mojom::AppInfoPtr>::Read(
    ::apps::mojom::AppInfo::DataView input,
    ::apps::mojom::AppInfoPtr* output) {
  bool success = true;
  ::apps::mojom::AppInfoPtr result(::apps::mojom::AppInfo::New());
  
      if (!input.ReadId(&result->id))
        success = false;
      if (!input.ReadType(&result->type))
        success = false;
      if (!input.ReadPreferred(&result->preferred))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif