// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_AVAILABLE_OFFLINE_CONTENT_MOJOM_SHARED_INTERNAL_H_
#define CHROME_COMMON_AVAILABLE_OFFLINE_CONTENT_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "url/mojom/url.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace chrome {
namespace mojom {
namespace internal {
class AvailableOfflineContent_Data;
class AvailableOfflineContentSummary_Data;

struct AvailableContentType_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
      case 4:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  AvailableOfflineContent_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AvailableOfflineContent_Data));
      new (data()) AvailableOfflineContent_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AvailableOfflineContent_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AvailableOfflineContent_Data>(index_);
    }
    AvailableOfflineContent_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> id;
  mojo::internal::Pointer<mojo::internal::String_Data> name_space;
  mojo::internal::Pointer<mojo::internal::String_Data> title;
  mojo::internal::Pointer<mojo::internal::String_Data> snippet;
  mojo::internal::Pointer<mojo::internal::String_Data> date_modified;
  mojo::internal::Pointer<mojo::internal::String_Data> attribution;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> thumbnail_data_uri;
  int32_t content_type;
  uint8_t padfinal_[4];

 private:
  AvailableOfflineContent_Data();
  ~AvailableOfflineContent_Data() = delete;
};
static_assert(sizeof(AvailableOfflineContent_Data) == 72,
              "Bad sizeof(AvailableOfflineContent_Data)");
// Used by AvailableOfflineContent::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct AvailableOfflineContent_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  AvailableOfflineContent_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~AvailableOfflineContent_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    AvailableOfflineContent_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    AvailableOfflineContent_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  AvailableOfflineContentSummary_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AvailableOfflineContentSummary_Data));
      new (data()) AvailableOfflineContentSummary_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AvailableOfflineContentSummary_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AvailableOfflineContentSummary_Data>(index_);
    }
    AvailableOfflineContentSummary_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t total_items;
  uint8_t has_prefetched_page : 1;
  uint8_t has_offline_page : 1;
  uint8_t has_video : 1;
  uint8_t has_audio : 1;
  uint8_t padfinal_[3];

 private:
  AvailableOfflineContentSummary_Data();
  ~AvailableOfflineContentSummary_Data() = delete;
};
static_assert(sizeof(AvailableOfflineContentSummary_Data) == 16,
              "Bad sizeof(AvailableOfflineContentSummary_Data)");
// Used by AvailableOfflineContentSummary::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct AvailableOfflineContentSummary_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  AvailableOfflineContentSummary_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~AvailableOfflineContentSummary_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    AvailableOfflineContentSummary_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    AvailableOfflineContentSummary_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  AvailableOfflineContentProvider_List_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AvailableOfflineContentProvider_List_Params_Data));
      new (data()) AvailableOfflineContentProvider_List_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AvailableOfflineContentProvider_List_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AvailableOfflineContentProvider_List_Params_Data>(index_);
    }
    AvailableOfflineContentProvider_List_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  AvailableOfflineContentProvider_List_Params_Data();
  ~AvailableOfflineContentProvider_List_Params_Data() = delete;
};
static_assert(sizeof(AvailableOfflineContentProvider_List_Params_Data) == 8,
              "Bad sizeof(AvailableOfflineContentProvider_List_Params_Data)");
class  AvailableOfflineContentProvider_List_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AvailableOfflineContentProvider_List_ResponseParams_Data));
      new (data()) AvailableOfflineContentProvider_List_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AvailableOfflineContentProvider_List_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AvailableOfflineContentProvider_List_ResponseParams_Data>(index_);
    }
    AvailableOfflineContentProvider_List_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::AvailableOfflineContent_Data>>> out;

 private:
  AvailableOfflineContentProvider_List_ResponseParams_Data();
  ~AvailableOfflineContentProvider_List_ResponseParams_Data() = delete;
};
static_assert(sizeof(AvailableOfflineContentProvider_List_ResponseParams_Data) == 16,
              "Bad sizeof(AvailableOfflineContentProvider_List_ResponseParams_Data)");
class  AvailableOfflineContentProvider_Summarize_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AvailableOfflineContentProvider_Summarize_Params_Data));
      new (data()) AvailableOfflineContentProvider_Summarize_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AvailableOfflineContentProvider_Summarize_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AvailableOfflineContentProvider_Summarize_Params_Data>(index_);
    }
    AvailableOfflineContentProvider_Summarize_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  AvailableOfflineContentProvider_Summarize_Params_Data();
  ~AvailableOfflineContentProvider_Summarize_Params_Data() = delete;
};
static_assert(sizeof(AvailableOfflineContentProvider_Summarize_Params_Data) == 8,
              "Bad sizeof(AvailableOfflineContentProvider_Summarize_Params_Data)");
class  AvailableOfflineContentProvider_Summarize_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AvailableOfflineContentProvider_Summarize_ResponseParams_Data));
      new (data()) AvailableOfflineContentProvider_Summarize_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AvailableOfflineContentProvider_Summarize_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AvailableOfflineContentProvider_Summarize_ResponseParams_Data>(index_);
    }
    AvailableOfflineContentProvider_Summarize_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::AvailableOfflineContentSummary_Data> out;

 private:
  AvailableOfflineContentProvider_Summarize_ResponseParams_Data();
  ~AvailableOfflineContentProvider_Summarize_ResponseParams_Data() = delete;
};
static_assert(sizeof(AvailableOfflineContentProvider_Summarize_ResponseParams_Data) == 16,
              "Bad sizeof(AvailableOfflineContentProvider_Summarize_ResponseParams_Data)");
class  AvailableOfflineContentProvider_LaunchItem_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AvailableOfflineContentProvider_LaunchItem_Params_Data));
      new (data()) AvailableOfflineContentProvider_LaunchItem_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AvailableOfflineContentProvider_LaunchItem_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AvailableOfflineContentProvider_LaunchItem_Params_Data>(index_);
    }
    AvailableOfflineContentProvider_LaunchItem_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> item_id;
  mojo::internal::Pointer<mojo::internal::String_Data> name_space;

 private:
  AvailableOfflineContentProvider_LaunchItem_Params_Data();
  ~AvailableOfflineContentProvider_LaunchItem_Params_Data() = delete;
};
static_assert(sizeof(AvailableOfflineContentProvider_LaunchItem_Params_Data) == 24,
              "Bad sizeof(AvailableOfflineContentProvider_LaunchItem_Params_Data)");
class  AvailableOfflineContentProvider_LaunchDownloadsPage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AvailableOfflineContentProvider_LaunchDownloadsPage_Params_Data));
      new (data()) AvailableOfflineContentProvider_LaunchDownloadsPage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AvailableOfflineContentProvider_LaunchDownloadsPage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AvailableOfflineContentProvider_LaunchDownloadsPage_Params_Data>(index_);
    }
    AvailableOfflineContentProvider_LaunchDownloadsPage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  AvailableOfflineContentProvider_LaunchDownloadsPage_Params_Data();
  ~AvailableOfflineContentProvider_LaunchDownloadsPage_Params_Data() = delete;
};
static_assert(sizeof(AvailableOfflineContentProvider_LaunchDownloadsPage_Params_Data) == 8,
              "Bad sizeof(AvailableOfflineContentProvider_LaunchDownloadsPage_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_AVAILABLE_OFFLINE_CONTENT_MOJOM_SHARED_INTERNAL_H_