// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_PRINTING_PUBLIC_MOJOM_PDF_NUP_CONVERTER_MOJOM_SHARED_INTERNAL_H_
#define CHROME_SERVICES_PRINTING_PUBLIC_MOJOM_PDF_NUP_CONVERTER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/shared_memory.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "url/mojom/url.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace printing {
namespace mojom {
namespace internal {

struct PdfNupConverter_Status_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  PdfNupConverter_NupPageConvert_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfNupConverter_NupPageConvert_Params_Data));
      new (data()) PdfNupConverter_NupPageConvert_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfNupConverter_NupPageConvert_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfNupConverter_NupPageConvert_Params_Data>(index_);
    }
    PdfNupConverter_NupPageConvert_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t pages_per_sheet;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> page_size;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::mojo_base::mojom::internal::ReadOnlySharedMemoryRegion_Data>>> pdf_page_regions;

 private:
  PdfNupConverter_NupPageConvert_Params_Data();
  ~PdfNupConverter_NupPageConvert_Params_Data() = delete;
};
static_assert(sizeof(PdfNupConverter_NupPageConvert_Params_Data) == 32,
              "Bad sizeof(PdfNupConverter_NupPageConvert_Params_Data)");
class  PdfNupConverter_NupPageConvert_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfNupConverter_NupPageConvert_ResponseParams_Data));
      new (data()) PdfNupConverter_NupPageConvert_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfNupConverter_NupPageConvert_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfNupConverter_NupPageConvert_ResponseParams_Data>(index_);
    }
    PdfNupConverter_NupPageConvert_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo_base::mojom::internal::ReadOnlySharedMemoryRegion_Data> pdf_region;

 private:
  PdfNupConverter_NupPageConvert_ResponseParams_Data();
  ~PdfNupConverter_NupPageConvert_ResponseParams_Data() = delete;
};
static_assert(sizeof(PdfNupConverter_NupPageConvert_ResponseParams_Data) == 24,
              "Bad sizeof(PdfNupConverter_NupPageConvert_ResponseParams_Data)");
class  PdfNupConverter_NupDocumentConvert_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfNupConverter_NupDocumentConvert_Params_Data));
      new (data()) PdfNupConverter_NupDocumentConvert_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfNupConverter_NupDocumentConvert_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfNupConverter_NupDocumentConvert_Params_Data>(index_);
    }
    PdfNupConverter_NupDocumentConvert_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t pages_per_sheet;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> page_size;
  mojo::internal::Pointer<::mojo_base::mojom::internal::ReadOnlySharedMemoryRegion_Data> src_pdf_region;

 private:
  PdfNupConverter_NupDocumentConvert_Params_Data();
  ~PdfNupConverter_NupDocumentConvert_Params_Data() = delete;
};
static_assert(sizeof(PdfNupConverter_NupDocumentConvert_Params_Data) == 32,
              "Bad sizeof(PdfNupConverter_NupDocumentConvert_Params_Data)");
class  PdfNupConverter_NupDocumentConvert_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfNupConverter_NupDocumentConvert_ResponseParams_Data));
      new (data()) PdfNupConverter_NupDocumentConvert_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfNupConverter_NupDocumentConvert_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfNupConverter_NupDocumentConvert_ResponseParams_Data>(index_);
    }
    PdfNupConverter_NupDocumentConvert_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo_base::mojom::internal::ReadOnlySharedMemoryRegion_Data> pdf_region;

 private:
  PdfNupConverter_NupDocumentConvert_ResponseParams_Data();
  ~PdfNupConverter_NupDocumentConvert_ResponseParams_Data() = delete;
};
static_assert(sizeof(PdfNupConverter_NupDocumentConvert_ResponseParams_Data) == 24,
              "Bad sizeof(PdfNupConverter_NupDocumentConvert_ResponseParams_Data)");
class  PdfNupConverter_SetWebContentsURL_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfNupConverter_SetWebContentsURL_Params_Data));
      new (data()) PdfNupConverter_SetWebContentsURL_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfNupConverter_SetWebContentsURL_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfNupConverter_SetWebContentsURL_Params_Data>(index_);
    }
    PdfNupConverter_SetWebContentsURL_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;

 private:
  PdfNupConverter_SetWebContentsURL_Params_Data();
  ~PdfNupConverter_SetWebContentsURL_Params_Data() = delete;
};
static_assert(sizeof(PdfNupConverter_SetWebContentsURL_Params_Data) == 16,
              "Bad sizeof(PdfNupConverter_SetWebContentsURL_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace printing

#endif  // CHROME_SERVICES_PRINTING_PUBLIC_MOJOM_PDF_NUP_CONVERTER_MOJOM_SHARED_INTERNAL_H_