// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_MEDIA_SESSION_PUBLIC_MOJOM_AUDIO_FOCUS_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_MEDIA_SESSION_PUBLIC_MOJOM_AUDIO_FOCUS_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/media_session/public/mojom/media_session.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace media_session {
namespace mojom {
namespace internal {

struct AudioFocusType_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class COMPONENT_EXPORT(MEDIA_SESSION_PUBLIC_MOJOM_SHARED) AudioFocusObserver_OnFocusGained_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusObserver_OnFocusGained_Params_Data));
      new (data()) AudioFocusObserver_OnFocusGained_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusObserver_OnFocusGained_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusObserver_OnFocusGained_Params_Data>(index_);
    }
    AudioFocusObserver_OnFocusGained_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data session;
  int32_t type;
  uint8_t padfinal_[4];

 private:
  AudioFocusObserver_OnFocusGained_Params_Data();
  ~AudioFocusObserver_OnFocusGained_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusObserver_OnFocusGained_Params_Data) == 24,
              "Bad sizeof(AudioFocusObserver_OnFocusGained_Params_Data)");
class COMPONENT_EXPORT(MEDIA_SESSION_PUBLIC_MOJOM_SHARED) AudioFocusObserver_OnFocusLost_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusObserver_OnFocusLost_Params_Data));
      new (data()) AudioFocusObserver_OnFocusLost_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusObserver_OnFocusLost_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusObserver_OnFocusLost_Params_Data>(index_);
    }
    AudioFocusObserver_OnFocusLost_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data session;

 private:
  AudioFocusObserver_OnFocusLost_Params_Data();
  ~AudioFocusObserver_OnFocusLost_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusObserver_OnFocusLost_Params_Data) == 16,
              "Bad sizeof(AudioFocusObserver_OnFocusLost_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace media_session

#endif  // SERVICES_MEDIA_SESSION_PUBLIC_MOJOM_AUDIO_FOCUS_MOJOM_SHARED_INTERNAL_H_