// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_HOST_RESOLVER_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_HOST_RESOLVER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "net/interfaces/address_list.mojom-shared-internal.h"
#include "services/network/public/mojom/network_param.mojom-shared-internal.h"
#include "services/network/public/mojom/url_loader.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace network {
namespace mojom {
namespace internal {
class ResolveHostParameters_Data;

struct ResolveHostParameters_DnsQueryType_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  ResolveHostParameters_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ResolveHostParameters_Data));
      new (data()) ResolveHostParameters_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ResolveHostParameters_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ResolveHostParameters_Data>(index_);
    }
    ResolveHostParameters_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t dns_query_type;
  int32_t initial_priority;
  mojo::internal::Handle_Data control_handle;
  uint8_t include_canonical_name : 1;
  uint8_t loopback_only : 1;
  uint8_t is_speculative : 1;
  uint8_t padfinal_[3];

 private:
  ResolveHostParameters_Data();
  ~ResolveHostParameters_Data() = delete;
};
static_assert(sizeof(ResolveHostParameters_Data) == 24,
              "Bad sizeof(ResolveHostParameters_Data)");
// Used by ResolveHostParameters::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct ResolveHostParameters_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  ResolveHostParameters_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~ResolveHostParameters_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    ResolveHostParameters_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    ResolveHostParameters_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  ResolveHostHandle_Cancel_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ResolveHostHandle_Cancel_Params_Data));
      new (data()) ResolveHostHandle_Cancel_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ResolveHostHandle_Cancel_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ResolveHostHandle_Cancel_Params_Data>(index_);
    }
    ResolveHostHandle_Cancel_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t padfinal_[4];

 private:
  ResolveHostHandle_Cancel_Params_Data();
  ~ResolveHostHandle_Cancel_Params_Data() = delete;
};
static_assert(sizeof(ResolveHostHandle_Cancel_Params_Data) == 16,
              "Bad sizeof(ResolveHostHandle_Cancel_Params_Data)");
class  ResolveHostClient_OnComplete_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ResolveHostClient_OnComplete_Params_Data));
      new (data()) ResolveHostClient_OnComplete_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ResolveHostClient_OnComplete_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ResolveHostClient_OnComplete_Params_Data>(index_);
    }
    ResolveHostClient_OnComplete_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::net::interfaces::internal::AddressList_Data> resolved_addresses;

 private:
  ResolveHostClient_OnComplete_Params_Data();
  ~ResolveHostClient_OnComplete_Params_Data() = delete;
};
static_assert(sizeof(ResolveHostClient_OnComplete_Params_Data) == 24,
              "Bad sizeof(ResolveHostClient_OnComplete_Params_Data)");
class  HostResolver_ResolveHost_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(HostResolver_ResolveHost_Params_Data));
      new (data()) HostResolver_ResolveHost_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    HostResolver_ResolveHost_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<HostResolver_ResolveHost_Params_Data>(index_);
    }
    HostResolver_ResolveHost_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::network::mojom::internal::HostPortPair_Data> host;
  mojo::internal::Pointer<internal::ResolveHostParameters_Data> optional_parameters;
  mojo::internal::Interface_Data response_client;

 private:
  HostResolver_ResolveHost_Params_Data();
  ~HostResolver_ResolveHost_Params_Data() = delete;
};
static_assert(sizeof(HostResolver_ResolveHost_Params_Data) == 32,
              "Bad sizeof(HostResolver_ResolveHost_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_HOST_RESOLVER_MOJOM_SHARED_INTERNAL_H_