// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/network/public/mojom/p2p.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "services/network/public/mojom/p2p.mojom-shared-message-ids.h"
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "net/interfaces/ip_address_struct_traits.h"
#include "net/interfaces/ip_endpoint_struct_traits.h"
#include "services/network/public/cpp/mutable_network_traffic_annotation_tag_mojom_traits.h"
#include "services/network/public/cpp/p2p_param_traits.h"
namespace network {
namespace mojom {
const char P2PNetworkNotificationClient::Name_[] = "network.mojom.P2PNetworkNotificationClient";

P2PNetworkNotificationClientProxy::P2PNetworkNotificationClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}
class P2PNetworkNotificationClientProxy_NetworkListChanged_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PNetworkNotificationClientProxy_NetworkListChanged_Message(
      uint32_t message_flags
      , const std::vector<net::NetworkInterface>& param_networks
      , const net::IPAddress& param_default_ipv4_local_address
      , const net::IPAddress& param_default_ipv6_local_address
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PNetworkNotificationClient_NetworkListChanged_Name,
          message_flags)
      , param_networks_(std::move(param_networks))
      , param_default_ipv4_local_address_(std::move(param_default_ipv4_local_address))
      , param_default_ipv6_local_address_(std::move(param_default_ipv6_local_address)){}
  ~P2PNetworkNotificationClientProxy_NetworkListChanged_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      const std::vector<net::NetworkInterface>& param_networks, const net::IPAddress& param_default_ipv4_local_address, const net::IPAddress& param_default_ipv6_local_address) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PNetworkNotificationClientProxy_NetworkListChanged_Message>(
          kFlags
          , std::move(param_networks)
          , std::move(param_default_ipv4_local_address)
          , std::move(param_default_ipv6_local_address)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PNetworkNotificationClient_NetworkListChanged_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PNetworkNotificationClient_NetworkListChanged_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->networks)::BaseType::BufferWriter
      networks_writer;
  const mojo::internal::ContainerValidateParams networks_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::network::mojom::NetworkInterfaceDataView>>(
      param_networks, buffer, &networks_writer, &networks_validate_params,
      &serialization_context);
  params->networks.Set(
      networks_writer.is_null() ? nullptr : networks_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->networks.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null networks in P2PNetworkNotificationClient.NetworkListChanged request");
  typename decltype(params->default_ipv4_local_address)::BaseType::BufferWriter
      default_ipv4_local_address_writer;
  mojo::internal::Serialize<::net::interfaces::IPAddressDataView>(
      param_default_ipv4_local_address, buffer, &default_ipv4_local_address_writer, &serialization_context);
  params->default_ipv4_local_address.Set(
      default_ipv4_local_address_writer.is_null() ? nullptr : default_ipv4_local_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->default_ipv4_local_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null default_ipv4_local_address in P2PNetworkNotificationClient.NetworkListChanged request");
  typename decltype(params->default_ipv6_local_address)::BaseType::BufferWriter
      default_ipv6_local_address_writer;
  mojo::internal::Serialize<::net::interfaces::IPAddressDataView>(
      param_default_ipv6_local_address, buffer, &default_ipv6_local_address_writer, &serialization_context);
  params->default_ipv6_local_address.Set(
      default_ipv6_local_address_writer.is_null() ? nullptr : default_ipv6_local_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->default_ipv6_local_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null default_ipv6_local_address in P2PNetworkNotificationClient.NetworkListChanged request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PNetworkNotificationClient* impl) {
    impl->NetworkListChanged(
        std::move(param_networks_),
        std::move(param_default_ipv4_local_address_),
        std::move(param_default_ipv6_local_address_));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PNetworkNotificationClient_NetworkListChanged_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  typename decltype(params->networks)::BaseType::BufferWriter
      networks_writer;
  const mojo::internal::ContainerValidateParams networks_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::network::mojom::NetworkInterfaceDataView>>(
      param_networks_, buffer, &networks_writer, &networks_validate_params,
      serialization_context);
  params->networks.Set(
      networks_writer.is_null() ? nullptr : networks_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->networks.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null networks in P2PNetworkNotificationClient.NetworkListChanged request");
  typename decltype(params->default_ipv4_local_address)::BaseType::BufferWriter
      default_ipv4_local_address_writer;
  mojo::internal::Serialize<::net::interfaces::IPAddressDataView>(
      param_default_ipv4_local_address_, buffer, &default_ipv4_local_address_writer, serialization_context);
  params->default_ipv4_local_address.Set(
      default_ipv4_local_address_writer.is_null() ? nullptr : default_ipv4_local_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->default_ipv4_local_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null default_ipv4_local_address in P2PNetworkNotificationClient.NetworkListChanged request");
  typename decltype(params->default_ipv6_local_address)::BaseType::BufferWriter
      default_ipv6_local_address_writer;
  mojo::internal::Serialize<::net::interfaces::IPAddressDataView>(
      param_default_ipv6_local_address_, buffer, &default_ipv6_local_address_writer, serialization_context);
  params->default_ipv6_local_address.Set(
      default_ipv6_local_address_writer.is_null() ? nullptr : default_ipv6_local_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->default_ipv6_local_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null default_ipv6_local_address in P2PNetworkNotificationClient.NetworkListChanged request");
  }
  std::vector<net::NetworkInterface> param_networks_;
  net::IPAddress param_default_ipv4_local_address_;
  net::IPAddress param_default_ipv6_local_address_;

  DISALLOW_COPY_AND_ASSIGN(P2PNetworkNotificationClientProxy_NetworkListChanged_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PNetworkNotificationClientProxy_NetworkListChanged_Message::kMessageTag = {};

void P2PNetworkNotificationClientProxy::NetworkListChanged(
    const std::vector<net::NetworkInterface>& in_networks, const net::IPAddress& in_default_ipv4_local_address, const net::IPAddress& in_default_ipv6_local_address) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::P2PNetworkNotificationClient::NetworkListChanged");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = P2PNetworkNotificationClientProxy_NetworkListChanged_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_networks), std::move(in_default_ipv4_local_address), std::move(in_default_ipv6_local_address));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PNetworkNotificationClient::Name_);
  message.set_method_name("NetworkListChanged");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool P2PNetworkNotificationClientStubDispatch::Accept(
    P2PNetworkNotificationClient* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kP2PNetworkNotificationClient_NetworkListChanged_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PNetworkNotificationClient::NetworkListChanged",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            P2PNetworkNotificationClientProxy_NetworkListChanged_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::P2PNetworkNotificationClient_NetworkListChanged_Params_Data* params =
          reinterpret_cast<internal::P2PNetworkNotificationClient_NetworkListChanged_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::vector<net::NetworkInterface> p_networks{};
      net::IPAddress p_default_ipv4_local_address{};
      net::IPAddress p_default_ipv6_local_address{};
      P2PNetworkNotificationClient_NetworkListChanged_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadNetworks(&p_networks))
        success = false;
      if (!input_data_view.ReadDefaultIpv4LocalAddress(&p_default_ipv4_local_address))
        success = false;
      if (!input_data_view.ReadDefaultIpv6LocalAddress(&p_default_ipv6_local_address))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "P2PNetworkNotificationClient::NetworkListChanged deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->NetworkListChanged(
std::move(p_networks), 
std::move(p_default_ipv4_local_address), 
std::move(p_default_ipv6_local_address));
      return true;
    }
  }
  return false;
}

// static
bool P2PNetworkNotificationClientStubDispatch::AcceptWithResponder(
    P2PNetworkNotificationClient* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kP2PNetworkNotificationClient_NetworkListChanged_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PNetworkNotificationClient::NetworkListChanged",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool P2PNetworkNotificationClientRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "P2PNetworkNotificationClient RequestValidator");

  switch (message->header()->name) {
    case internal::kP2PNetworkNotificationClient_NetworkListChanged_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PNetworkNotificationClient_NetworkListChanged_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

void P2PNetworkNotificationClientInterceptorForTesting::NetworkListChanged(const std::vector<net::NetworkInterface>& networks, const net::IPAddress& default_ipv4_local_address, const net::IPAddress& default_ipv6_local_address) {
  GetForwardingInterface()->NetworkListChanged(std::move(networks), std::move(default_ipv4_local_address), std::move(default_ipv6_local_address));
}
P2PNetworkNotificationClientAsyncWaiter::P2PNetworkNotificationClientAsyncWaiter(
    P2PNetworkNotificationClient* proxy) : proxy_(proxy) {}

P2PNetworkNotificationClientAsyncWaiter::~P2PNetworkNotificationClientAsyncWaiter() = default;


const char P2PSocketManager::Name_[] = "network.mojom.P2PSocketManager";

class P2PSocketManager_GetHostAddress_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  P2PSocketManager_GetHostAddress_ForwardToCallback(
      P2PSocketManager::GetHostAddressCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  P2PSocketManager::GetHostAddressCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(P2PSocketManager_GetHostAddress_ForwardToCallback);
};

P2PSocketManagerProxy::P2PSocketManagerProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}
class P2PSocketManagerProxy_StartNetworkNotifications_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PSocketManagerProxy_StartNetworkNotifications_Message(
      uint32_t message_flags
      , P2PNetworkNotificationClientPtr param_client
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PSocketManager_StartNetworkNotifications_Name,
          message_flags)
      , param_client_(param_client.PassInterface()){}
  ~P2PSocketManagerProxy_StartNetworkNotifications_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      P2PNetworkNotificationClientPtr param_client) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PSocketManagerProxy_StartNetworkNotifications_Message>(
          kFlags
          , std::move(param_client)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PSocketManager_StartNetworkNotifications_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PSocketManager_StartNetworkNotifications_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::network::mojom::P2PNetworkNotificationClientPtrDataView>(
      param_client, &params->client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in P2PSocketManager.StartNetworkNotifications request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PSocketManager* impl) {
    impl->StartNetworkNotifications(
        P2PNetworkNotificationClientPtr(std::move(param_client_)));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PSocketManager_StartNetworkNotifications_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  mojo::internal::Serialize<::network::mojom::P2PNetworkNotificationClientPtrDataView>(
      param_client_, &params->client, serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in P2PSocketManager.StartNetworkNotifications request");
  }
  P2PNetworkNotificationClientPtrInfo param_client_;

  DISALLOW_COPY_AND_ASSIGN(P2PSocketManagerProxy_StartNetworkNotifications_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PSocketManagerProxy_StartNetworkNotifications_Message::kMessageTag = {};

void P2PSocketManagerProxy::StartNetworkNotifications(
    P2PNetworkNotificationClientPtr in_client) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::P2PSocketManager::StartNetworkNotifications");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = P2PSocketManagerProxy_StartNetworkNotifications_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_client));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PSocketManager::Name_);
  message.set_method_name("StartNetworkNotifications");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class P2PSocketManagerProxy_GetHostAddress_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PSocketManagerProxy_GetHostAddress_Message(
      uint32_t message_flags
      , const std::string& param_host_name
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PSocketManager_GetHostAddress_Name,
          message_flags)
      , param_host_name_(std::move(param_host_name)){}
  ~P2PSocketManagerProxy_GetHostAddress_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      const std::string& param_host_name) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PSocketManagerProxy_GetHostAddress_Message>(
          kFlags
          , std::move(param_host_name)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PSocketManager_GetHostAddress_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PSocketManager_GetHostAddress_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->host_name)::BaseType::BufferWriter
      host_name_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      param_host_name, buffer, &host_name_writer, &serialization_context);
  params->host_name.Set(
      host_name_writer.is_null() ? nullptr : host_name_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->host_name.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null host_name in P2PSocketManager.GetHostAddress request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PSocketManager* impl, P2PSocketManager::GetHostAddressCallback callback) {
    impl->GetHostAddress(
        std::move(param_host_name_), std::move(callback));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PSocketManager_GetHostAddress_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  typename decltype(params->host_name)::BaseType::BufferWriter
      host_name_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      param_host_name_, buffer, &host_name_writer, serialization_context);
  params->host_name.Set(
      host_name_writer.is_null() ? nullptr : host_name_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->host_name.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null host_name in P2PSocketManager.GetHostAddress request");
  }
  std::string param_host_name_;

  DISALLOW_COPY_AND_ASSIGN(P2PSocketManagerProxy_GetHostAddress_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PSocketManagerProxy_GetHostAddress_Message::kMessageTag = {};

void P2PSocketManagerProxy::GetHostAddress(
    const std::string& in_host_name, GetHostAddressCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::P2PSocketManager::GetHostAddress");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = P2PSocketManagerProxy_GetHostAddress_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_host_name));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PSocketManager::Name_);
  message.set_method_name("GetHostAddress");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new P2PSocketManager_GetHostAddress_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class P2PSocketManagerProxy_CreateSocket_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PSocketManagerProxy_CreateSocket_Message(
      uint32_t message_flags
      , network::P2PSocketType param_type
      , const net::IPEndPoint& param_local_address
      , const network::P2PPortRange& param_port_range
      , const network::P2PHostAndIPEndPoint& param_remote_address
      , P2PSocketClientPtr param_client
      , P2PSocketRequest param_socket
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PSocketManager_CreateSocket_Name,
          message_flags)
      , param_type_(std::move(param_type))
      , param_local_address_(std::move(param_local_address))
      , param_port_range_(std::move(param_port_range))
      , param_remote_address_(std::move(param_remote_address))
      , param_client_(param_client.PassInterface())
      , param_socket_(std::move(param_socket)){}
  ~P2PSocketManagerProxy_CreateSocket_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      network::P2PSocketType param_type, const net::IPEndPoint& param_local_address, const network::P2PPortRange& param_port_range, const network::P2PHostAndIPEndPoint& param_remote_address, P2PSocketClientPtr param_client, P2PSocketRequest param_socket) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PSocketManagerProxy_CreateSocket_Message>(
          kFlags
          , std::move(param_type)
          , std::move(param_local_address)
          , std::move(param_port_range)
          , std::move(param_remote_address)
          , std::move(param_client)
          , std::move(param_socket)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PSocketManager_CreateSocket_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PSocketManager_CreateSocket_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::network::mojom::P2PSocketType>(
      param_type, &params->type);
  typename decltype(params->local_address)::BaseType::BufferWriter
      local_address_writer;
  mojo::internal::Serialize<::net::interfaces::IPEndPointDataView>(
      param_local_address, buffer, &local_address_writer, &serialization_context);
  params->local_address.Set(
      local_address_writer.is_null() ? nullptr : local_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->local_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null local_address in P2PSocketManager.CreateSocket request");
  typename decltype(params->port_range)::BaseType::BufferWriter
      port_range_writer;
  mojo::internal::Serialize<::network::mojom::P2PPortRangeDataView>(
      param_port_range, buffer, &port_range_writer, &serialization_context);
  params->port_range.Set(
      port_range_writer.is_null() ? nullptr : port_range_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->port_range.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null port_range in P2PSocketManager.CreateSocket request");
  typename decltype(params->remote_address)::BaseType::BufferWriter
      remote_address_writer;
  mojo::internal::Serialize<::network::mojom::P2PHostAndIPEndPointDataView>(
      param_remote_address, buffer, &remote_address_writer, &serialization_context);
  params->remote_address.Set(
      remote_address_writer.is_null() ? nullptr : remote_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->remote_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null remote_address in P2PSocketManager.CreateSocket request");
  mojo::internal::Serialize<::network::mojom::P2PSocketClientPtrDataView>(
      param_client, &params->client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in P2PSocketManager.CreateSocket request");
  mojo::internal::Serialize<::network::mojom::P2PSocketRequestDataView>(
      param_socket, &params->socket, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->socket),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid socket in P2PSocketManager.CreateSocket request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PSocketManager* impl) {
    impl->CreateSocket(
        std::move(param_type_),
        std::move(param_local_address_),
        std::move(param_port_range_),
        std::move(param_remote_address_),
        P2PSocketClientPtr(std::move(param_client_)),
        std::move(param_socket_));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PSocketManager_CreateSocket_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  mojo::internal::Serialize<::network::mojom::P2PSocketType>(
      param_type_, &params->type);
  typename decltype(params->local_address)::BaseType::BufferWriter
      local_address_writer;
  mojo::internal::Serialize<::net::interfaces::IPEndPointDataView>(
      param_local_address_, buffer, &local_address_writer, serialization_context);
  params->local_address.Set(
      local_address_writer.is_null() ? nullptr : local_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->local_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null local_address in P2PSocketManager.CreateSocket request");
  typename decltype(params->port_range)::BaseType::BufferWriter
      port_range_writer;
  mojo::internal::Serialize<::network::mojom::P2PPortRangeDataView>(
      param_port_range_, buffer, &port_range_writer, serialization_context);
  params->port_range.Set(
      port_range_writer.is_null() ? nullptr : port_range_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->port_range.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null port_range in P2PSocketManager.CreateSocket request");
  typename decltype(params->remote_address)::BaseType::BufferWriter
      remote_address_writer;
  mojo::internal::Serialize<::network::mojom::P2PHostAndIPEndPointDataView>(
      param_remote_address_, buffer, &remote_address_writer, serialization_context);
  params->remote_address.Set(
      remote_address_writer.is_null() ? nullptr : remote_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->remote_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null remote_address in P2PSocketManager.CreateSocket request");
  mojo::internal::Serialize<::network::mojom::P2PSocketClientPtrDataView>(
      param_client_, &params->client, serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in P2PSocketManager.CreateSocket request");
  mojo::internal::Serialize<::network::mojom::P2PSocketRequestDataView>(
      param_socket_, &params->socket, serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->socket),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid socket in P2PSocketManager.CreateSocket request");
  }
  network::P2PSocketType param_type_;
  net::IPEndPoint param_local_address_;
  network::P2PPortRange param_port_range_;
  network::P2PHostAndIPEndPoint param_remote_address_;
  P2PSocketClientPtrInfo param_client_;
  P2PSocketRequest param_socket_;

  DISALLOW_COPY_AND_ASSIGN(P2PSocketManagerProxy_CreateSocket_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PSocketManagerProxy_CreateSocket_Message::kMessageTag = {};

void P2PSocketManagerProxy::CreateSocket(
    network::P2PSocketType in_type, const net::IPEndPoint& in_local_address, const network::P2PPortRange& in_port_range, const network::P2PHostAndIPEndPoint& in_remote_address, P2PSocketClientPtr in_client, P2PSocketRequest in_socket) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::P2PSocketManager::CreateSocket");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = P2PSocketManagerProxy_CreateSocket_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_type), std::move(in_local_address), std::move(in_port_range), std::move(in_remote_address), std::move(in_client), std::move(in_socket));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PSocketManager::Name_);
  message.set_method_name("CreateSocket");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class P2PSocketManager_GetHostAddress_ProxyToResponder {
 public:
  static P2PSocketManager::GetHostAddressCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<P2PSocketManager_GetHostAddress_ProxyToResponder> proxy(
        new P2PSocketManager_GetHostAddress_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&P2PSocketManager_GetHostAddress_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~P2PSocketManager_GetHostAddress_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  P2PSocketManager_GetHostAddress_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "P2PSocketManager::GetHostAddressCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      const std::vector<net::IPAddress>& in_addresses);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(P2PSocketManager_GetHostAddress_ProxyToResponder);
};
class P2PSocketManager_GetHostAddress_Response_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PSocketManager_GetHostAddress_Response_Message(
      uint32_t message_flags
      , const std::vector<net::IPAddress>& param_addresses
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PSocketManager_GetHostAddress_Name,
          message_flags)
      , param_addresses_(std::move(param_addresses)){}
  ~P2PSocketManager_GetHostAddress_Response_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool is_sync,
      const std::vector<net::IPAddress>& param_addresses) {

    
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PSocketManager_GetHostAddress_Response_Message>(
          kFlags
          , std::move(param_addresses)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PSocketManager_GetHostAddress_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PSocketManager_GetHostAddress_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->addresses)::BaseType::BufferWriter
      addresses_writer;
  const mojo::internal::ContainerValidateParams addresses_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::net::interfaces::IPAddressDataView>>(
      param_addresses, buffer, &addresses_writer, &addresses_validate_params,
      &serialization_context);
  params->addresses.Set(
      addresses_writer.is_null() ? nullptr : addresses_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->addresses.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null addresses in P2PSocketManager.GetHostAddress response");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PSocketManager::GetHostAddressCallback* callback) {
    std::move(*callback).Run(
        std::move(param_addresses_));
  }



 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PSocketManager_GetHostAddress_ResponseParams_Data::BufferWriter
        params;
    params.Allocate(buffer);
  typename decltype(params->addresses)::BaseType::BufferWriter
      addresses_writer;
  const mojo::internal::ContainerValidateParams addresses_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::net::interfaces::IPAddressDataView>>(
      param_addresses_, buffer, &addresses_writer, &addresses_validate_params,
      serialization_context);
  params->addresses.Set(
      addresses_writer.is_null() ? nullptr : addresses_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->addresses.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null addresses in P2PSocketManager.GetHostAddress response");
  }
  std::vector<net::IPAddress> param_addresses_;

  DISALLOW_COPY_AND_ASSIGN(P2PSocketManager_GetHostAddress_Response_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PSocketManager_GetHostAddress_Response_Message::kMessageTag = {};

bool P2PSocketManager_GetHostAddress_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "network::mojom::P2PSocketManager::GetHostAddressCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);
  if (!message->is_serialized()) {
    auto context =
        message->TakeUnserializedContext<P2PSocketManager_GetHostAddress_Response_Message>();
    if (!context) {
      // The Message was not of the expected type. It may be a valid message
      // which was build using a different variant of these bindings. Force
      // serialization before dispatch in this case.
      message->SerializeIfNecessary();
    } else {
      if (!callback_.is_null())
        context->Dispatch(&callback_);
      return true;
    }
  }

  DCHECK(message->is_serialized());
  internal::P2PSocketManager_GetHostAddress_ResponseParams_Data* params =
      reinterpret_cast<
          internal::P2PSocketManager_GetHostAddress_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  std::vector<net::IPAddress> p_addresses{};
  P2PSocketManager_GetHostAddress_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadAddresses(&p_addresses))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "P2PSocketManager::GetHostAddress response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_addresses));
  return true;
}

void P2PSocketManager_GetHostAddress_ProxyToResponder::Run(
    const std::vector<net::IPAddress>& in_addresses) {
  const bool kSerialize = responder_->PrefersSerializedMessages();
  auto message = P2PSocketManager_GetHostAddress_Response_Message::Build(kSerialize, is_sync_, std::move(in_addresses));

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketManager::GetHostAddressCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PSocketManager::Name_);
  message.set_method_name("GetHostAddress");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool P2PSocketManagerStubDispatch::Accept(
    P2PSocketManager* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kP2PSocketManager_StartNetworkNotifications_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketManager::StartNetworkNotifications",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            P2PSocketManagerProxy_StartNetworkNotifications_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::P2PSocketManager_StartNetworkNotifications_Params_Data* params =
          reinterpret_cast<internal::P2PSocketManager_StartNetworkNotifications_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      P2PNetworkNotificationClientPtr p_client{};
      P2PSocketManager_StartNetworkNotifications_ParamsDataView input_data_view(params, &serialization_context);
      
      p_client =
          input_data_view.TakeClient<decltype(p_client)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "P2PSocketManager::StartNetworkNotifications deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->StartNetworkNotifications(
std::move(p_client));
      return true;
    }
    case internal::kP2PSocketManager_GetHostAddress_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketManager::GetHostAddress",
               "message", message->name());
#endif
      break;
    }
    case internal::kP2PSocketManager_CreateSocket_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketManager::CreateSocket",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            P2PSocketManagerProxy_CreateSocket_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::P2PSocketManager_CreateSocket_Params_Data* params =
          reinterpret_cast<internal::P2PSocketManager_CreateSocket_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      network::P2PSocketType p_type{};
      net::IPEndPoint p_local_address{};
      network::P2PPortRange p_port_range{};
      network::P2PHostAndIPEndPoint p_remote_address{};
      P2PSocketClientPtr p_client{};
      P2PSocketRequest p_socket{};
      P2PSocketManager_CreateSocket_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadType(&p_type))
        success = false;
      if (!input_data_view.ReadLocalAddress(&p_local_address))
        success = false;
      if (!input_data_view.ReadPortRange(&p_port_range))
        success = false;
      if (!input_data_view.ReadRemoteAddress(&p_remote_address))
        success = false;
      p_client =
          input_data_view.TakeClient<decltype(p_client)>();
      p_socket =
          input_data_view.TakeSocket<decltype(p_socket)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "P2PSocketManager::CreateSocket deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateSocket(
std::move(p_type), 
std::move(p_local_address), 
std::move(p_port_range), 
std::move(p_remote_address), 
std::move(p_client), 
std::move(p_socket));
      return true;
    }
  }
  return false;
}

// static
bool P2PSocketManagerStubDispatch::AcceptWithResponder(
    P2PSocketManager* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kP2PSocketManager_StartNetworkNotifications_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketManager::StartNetworkNotifications",
               "message", message->name());
#endif
      break;
    }
    case internal::kP2PSocketManager_GetHostAddress_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketManager::GetHostAddress",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            P2PSocketManagerProxy_GetHostAddress_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was built using a different variant of these bindings. Force
          // serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          P2PSocketManager::GetHostAddressCallback callback =
              P2PSocketManager_GetHostAddress_ProxyToResponder::CreateCallback(
                  message->request_id(),
                  message->has_flag(mojo::Message::kFlagIsSync),
                  std::move(responder));
          context->Dispatch(impl, std::move(callback));
          return true;
        }
      }

      internal::P2PSocketManager_GetHostAddress_Params_Data* params =
          reinterpret_cast<
              internal::P2PSocketManager_GetHostAddress_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_host_name{};
      P2PSocketManager_GetHostAddress_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadHostName(&p_host_name))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "P2PSocketManager::GetHostAddress deserializer");
        return false;
      }
      P2PSocketManager::GetHostAddressCallback callback =
          P2PSocketManager_GetHostAddress_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->GetHostAddress(
std::move(p_host_name), std::move(callback));
      return true;
    }
    case internal::kP2PSocketManager_CreateSocket_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketManager::CreateSocket",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool P2PSocketManagerRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "P2PSocketManager RequestValidator");

  switch (message->header()->name) {
    case internal::kP2PSocketManager_StartNetworkNotifications_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PSocketManager_StartNetworkNotifications_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kP2PSocketManager_GetHostAddress_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PSocketManager_GetHostAddress_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kP2PSocketManager_CreateSocket_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PSocketManager_CreateSocket_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool P2PSocketManagerResponseValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "P2PSocketManager ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kP2PSocketManager_GetHostAddress_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PSocketManager_GetHostAddress_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
void P2PSocketManagerInterceptorForTesting::StartNetworkNotifications(P2PNetworkNotificationClientPtr client) {
  GetForwardingInterface()->StartNetworkNotifications(std::move(client));
}
void P2PSocketManagerInterceptorForTesting::GetHostAddress(const std::string& host_name, GetHostAddressCallback callback) {
  GetForwardingInterface()->GetHostAddress(std::move(host_name), std::move(callback));
}
void P2PSocketManagerInterceptorForTesting::CreateSocket(network::P2PSocketType type, const net::IPEndPoint& local_address, const network::P2PPortRange& port_range, const network::P2PHostAndIPEndPoint& remote_address, P2PSocketClientPtr client, P2PSocketRequest socket) {
  GetForwardingInterface()->CreateSocket(std::move(type), std::move(local_address), std::move(port_range), std::move(remote_address), std::move(client), std::move(socket));
}
P2PSocketManagerAsyncWaiter::P2PSocketManagerAsyncWaiter(
    P2PSocketManager* proxy) : proxy_(proxy) {}

P2PSocketManagerAsyncWaiter::~P2PSocketManagerAsyncWaiter() = default;

void P2PSocketManagerAsyncWaiter::GetHostAddress(
    const std::string& host_name, std::vector<net::IPAddress>* out_addresses) {
  base::RunLoop loop;
  proxy_->GetHostAddress(std::move(host_name),
      base::BindOnce(
          [](base::RunLoop* loop,
             std::vector<net::IPAddress>* out_addresses
,
             const std::vector<net::IPAddress>& addresses) {*out_addresses = std::move(addresses);
            loop->Quit();
          },
          &loop,
          out_addresses));
  loop.Run();
}

const char P2PSocket::Name_[] = "network.mojom.P2PSocket";

P2PSocketProxy::P2PSocketProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}
class P2PSocketProxy_Send_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PSocketProxy_Send_Message(
      uint32_t message_flags
      , const std::vector<int8_t>& param_data
      , const network::P2PPacketInfo& param_packet_info
      , const net::MutableNetworkTrafficAnnotationTag& param_traffic_annotation
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PSocket_Send_Name,
          message_flags)
      , param_data_(std::move(param_data))
      , param_packet_info_(std::move(param_packet_info))
      , param_traffic_annotation_(std::move(param_traffic_annotation)){}
  ~P2PSocketProxy_Send_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      const std::vector<int8_t>& param_data, const network::P2PPacketInfo& param_packet_info, const net::MutableNetworkTrafficAnnotationTag& param_traffic_annotation) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PSocketProxy_Send_Message>(
          kFlags
          , std::move(param_data)
          , std::move(param_packet_info)
          , std::move(param_traffic_annotation)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PSocket_Send_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PSocket_Send_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->data)::BaseType::BufferWriter
      data_writer;
  const mojo::internal::ContainerValidateParams data_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<int8_t>>(
      param_data, buffer, &data_writer, &data_validate_params,
      &serialization_context);
  params->data.Set(
      data_writer.is_null() ? nullptr : data_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->data.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null data in P2PSocket.Send request");
  typename decltype(params->packet_info)::BaseType::BufferWriter
      packet_info_writer;
  mojo::internal::Serialize<::network::mojom::P2PPacketInfoDataView>(
      param_packet_info, buffer, &packet_info_writer, &serialization_context);
  params->packet_info.Set(
      packet_info_writer.is_null() ? nullptr : packet_info_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->packet_info.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null packet_info in P2PSocket.Send request");
  typename decltype(params->traffic_annotation)::BaseType::BufferWriter
      traffic_annotation_writer;
  mojo::internal::Serialize<::network::mojom::MutableNetworkTrafficAnnotationTagDataView>(
      param_traffic_annotation, buffer, &traffic_annotation_writer, &serialization_context);
  params->traffic_annotation.Set(
      traffic_annotation_writer.is_null() ? nullptr : traffic_annotation_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->traffic_annotation.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null traffic_annotation in P2PSocket.Send request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PSocket* impl) {
    impl->Send(
        std::move(param_data_),
        std::move(param_packet_info_),
        std::move(param_traffic_annotation_));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PSocket_Send_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  typename decltype(params->data)::BaseType::BufferWriter
      data_writer;
  const mojo::internal::ContainerValidateParams data_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<int8_t>>(
      param_data_, buffer, &data_writer, &data_validate_params,
      serialization_context);
  params->data.Set(
      data_writer.is_null() ? nullptr : data_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->data.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null data in P2PSocket.Send request");
  typename decltype(params->packet_info)::BaseType::BufferWriter
      packet_info_writer;
  mojo::internal::Serialize<::network::mojom::P2PPacketInfoDataView>(
      param_packet_info_, buffer, &packet_info_writer, serialization_context);
  params->packet_info.Set(
      packet_info_writer.is_null() ? nullptr : packet_info_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->packet_info.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null packet_info in P2PSocket.Send request");
  typename decltype(params->traffic_annotation)::BaseType::BufferWriter
      traffic_annotation_writer;
  mojo::internal::Serialize<::network::mojom::MutableNetworkTrafficAnnotationTagDataView>(
      param_traffic_annotation_, buffer, &traffic_annotation_writer, serialization_context);
  params->traffic_annotation.Set(
      traffic_annotation_writer.is_null() ? nullptr : traffic_annotation_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->traffic_annotation.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null traffic_annotation in P2PSocket.Send request");
  }
  std::vector<int8_t> param_data_;
  network::P2PPacketInfo param_packet_info_;
  net::MutableNetworkTrafficAnnotationTag param_traffic_annotation_;

  DISALLOW_COPY_AND_ASSIGN(P2PSocketProxy_Send_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PSocketProxy_Send_Message::kMessageTag = {};

void P2PSocketProxy::Send(
    const std::vector<int8_t>& in_data, const network::P2PPacketInfo& in_packet_info, const net::MutableNetworkTrafficAnnotationTag& in_traffic_annotation) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::P2PSocket::Send");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = P2PSocketProxy_Send_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_data), std::move(in_packet_info), std::move(in_traffic_annotation));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PSocket::Name_);
  message.set_method_name("Send");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class P2PSocketProxy_SetOption_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PSocketProxy_SetOption_Message(
      uint32_t message_flags
      , network::P2PSocketOption param_option
      , int32_t param_value
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PSocket_SetOption_Name,
          message_flags)
      , param_option_(std::move(param_option))
      , param_value_(std::move(param_value)){}
  ~P2PSocketProxy_SetOption_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      network::P2PSocketOption param_option, int32_t param_value) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PSocketProxy_SetOption_Message>(
          kFlags
          , std::move(param_option)
          , std::move(param_value)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PSocket_SetOption_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PSocket_SetOption_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::network::mojom::P2PSocketOption>(
      param_option, &params->option);
  params->value = param_value;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PSocket* impl) {
    impl->SetOption(
        std::move(param_option_),
        std::move(param_value_));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PSocket_SetOption_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  mojo::internal::Serialize<::network::mojom::P2PSocketOption>(
      param_option_, &params->option);
  params->value = param_value_;
  }
  network::P2PSocketOption param_option_;
  int32_t param_value_;

  DISALLOW_COPY_AND_ASSIGN(P2PSocketProxy_SetOption_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PSocketProxy_SetOption_Message::kMessageTag = {};

void P2PSocketProxy::SetOption(
    network::P2PSocketOption in_option, int32_t in_value) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::P2PSocket::SetOption");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = P2PSocketProxy_SetOption_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_option), std::move(in_value));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PSocket::Name_);
  message.set_method_name("SetOption");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool P2PSocketStubDispatch::Accept(
    P2PSocket* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kP2PSocket_Send_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocket::Send",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            P2PSocketProxy_Send_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::P2PSocket_Send_Params_Data* params =
          reinterpret_cast<internal::P2PSocket_Send_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::vector<int8_t> p_data{};
      network::P2PPacketInfo p_packet_info{};
      net::MutableNetworkTrafficAnnotationTag p_traffic_annotation{};
      P2PSocket_Send_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadData(&p_data))
        success = false;
      if (!input_data_view.ReadPacketInfo(&p_packet_info))
        success = false;
      if (!input_data_view.ReadTrafficAnnotation(&p_traffic_annotation))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "P2PSocket::Send deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->Send(
std::move(p_data), 
std::move(p_packet_info), 
std::move(p_traffic_annotation));
      return true;
    }
    case internal::kP2PSocket_SetOption_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocket::SetOption",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            P2PSocketProxy_SetOption_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::P2PSocket_SetOption_Params_Data* params =
          reinterpret_cast<internal::P2PSocket_SetOption_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      network::P2PSocketOption p_option{};
      int32_t p_value{};
      P2PSocket_SetOption_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadOption(&p_option))
        success = false;
      p_value = input_data_view.value();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "P2PSocket::SetOption deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetOption(
std::move(p_option), 
std::move(p_value));
      return true;
    }
  }
  return false;
}

// static
bool P2PSocketStubDispatch::AcceptWithResponder(
    P2PSocket* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kP2PSocket_Send_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocket::Send",
               "message", message->name());
#endif
      break;
    }
    case internal::kP2PSocket_SetOption_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocket::SetOption",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool P2PSocketRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "P2PSocket RequestValidator");

  switch (message->header()->name) {
    case internal::kP2PSocket_Send_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PSocket_Send_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kP2PSocket_SetOption_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PSocket_SetOption_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

void P2PSocketInterceptorForTesting::Send(const std::vector<int8_t>& data, const network::P2PPacketInfo& packet_info, const net::MutableNetworkTrafficAnnotationTag& traffic_annotation) {
  GetForwardingInterface()->Send(std::move(data), std::move(packet_info), std::move(traffic_annotation));
}
void P2PSocketInterceptorForTesting::SetOption(network::P2PSocketOption option, int32_t value) {
  GetForwardingInterface()->SetOption(std::move(option), std::move(value));
}
P2PSocketAsyncWaiter::P2PSocketAsyncWaiter(
    P2PSocket* proxy) : proxy_(proxy) {}

P2PSocketAsyncWaiter::~P2PSocketAsyncWaiter() = default;


const char P2PSocketClient::Name_[] = "network.mojom.P2PSocketClient";

P2PSocketClientProxy::P2PSocketClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}
class P2PSocketClientProxy_SocketCreated_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PSocketClientProxy_SocketCreated_Message(
      uint32_t message_flags
      , const net::IPEndPoint& param_local_address
      , const net::IPEndPoint& param_remote_address
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PSocketClient_SocketCreated_Name,
          message_flags)
      , param_local_address_(std::move(param_local_address))
      , param_remote_address_(std::move(param_remote_address)){}
  ~P2PSocketClientProxy_SocketCreated_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      const net::IPEndPoint& param_local_address, const net::IPEndPoint& param_remote_address) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PSocketClientProxy_SocketCreated_Message>(
          kFlags
          , std::move(param_local_address)
          , std::move(param_remote_address)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PSocketClient_SocketCreated_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PSocketClient_SocketCreated_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->local_address)::BaseType::BufferWriter
      local_address_writer;
  mojo::internal::Serialize<::net::interfaces::IPEndPointDataView>(
      param_local_address, buffer, &local_address_writer, &serialization_context);
  params->local_address.Set(
      local_address_writer.is_null() ? nullptr : local_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->local_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null local_address in P2PSocketClient.SocketCreated request");
  typename decltype(params->remote_address)::BaseType::BufferWriter
      remote_address_writer;
  mojo::internal::Serialize<::net::interfaces::IPEndPointDataView>(
      param_remote_address, buffer, &remote_address_writer, &serialization_context);
  params->remote_address.Set(
      remote_address_writer.is_null() ? nullptr : remote_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->remote_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null remote_address in P2PSocketClient.SocketCreated request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PSocketClient* impl) {
    impl->SocketCreated(
        std::move(param_local_address_),
        std::move(param_remote_address_));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PSocketClient_SocketCreated_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  typename decltype(params->local_address)::BaseType::BufferWriter
      local_address_writer;
  mojo::internal::Serialize<::net::interfaces::IPEndPointDataView>(
      param_local_address_, buffer, &local_address_writer, serialization_context);
  params->local_address.Set(
      local_address_writer.is_null() ? nullptr : local_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->local_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null local_address in P2PSocketClient.SocketCreated request");
  typename decltype(params->remote_address)::BaseType::BufferWriter
      remote_address_writer;
  mojo::internal::Serialize<::net::interfaces::IPEndPointDataView>(
      param_remote_address_, buffer, &remote_address_writer, serialization_context);
  params->remote_address.Set(
      remote_address_writer.is_null() ? nullptr : remote_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->remote_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null remote_address in P2PSocketClient.SocketCreated request");
  }
  net::IPEndPoint param_local_address_;
  net::IPEndPoint param_remote_address_;

  DISALLOW_COPY_AND_ASSIGN(P2PSocketClientProxy_SocketCreated_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PSocketClientProxy_SocketCreated_Message::kMessageTag = {};

void P2PSocketClientProxy::SocketCreated(
    const net::IPEndPoint& in_local_address, const net::IPEndPoint& in_remote_address) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::P2PSocketClient::SocketCreated");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = P2PSocketClientProxy_SocketCreated_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_local_address), std::move(in_remote_address));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PSocketClient::Name_);
  message.set_method_name("SocketCreated");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class P2PSocketClientProxy_SendComplete_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PSocketClientProxy_SendComplete_Message(
      uint32_t message_flags
      , const network::P2PSendPacketMetrics& param_send_metrics
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PSocketClient_SendComplete_Name,
          message_flags)
      , param_send_metrics_(std::move(param_send_metrics)){}
  ~P2PSocketClientProxy_SendComplete_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      const network::P2PSendPacketMetrics& param_send_metrics) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PSocketClientProxy_SendComplete_Message>(
          kFlags
          , std::move(param_send_metrics)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PSocketClient_SendComplete_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PSocketClient_SendComplete_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->send_metrics)::BaseType::BufferWriter
      send_metrics_writer;
  mojo::internal::Serialize<::network::mojom::P2PSendPacketMetricsDataView>(
      param_send_metrics, buffer, &send_metrics_writer, &serialization_context);
  params->send_metrics.Set(
      send_metrics_writer.is_null() ? nullptr : send_metrics_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->send_metrics.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null send_metrics in P2PSocketClient.SendComplete request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PSocketClient* impl) {
    impl->SendComplete(
        std::move(param_send_metrics_));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PSocketClient_SendComplete_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  typename decltype(params->send_metrics)::BaseType::BufferWriter
      send_metrics_writer;
  mojo::internal::Serialize<::network::mojom::P2PSendPacketMetricsDataView>(
      param_send_metrics_, buffer, &send_metrics_writer, serialization_context);
  params->send_metrics.Set(
      send_metrics_writer.is_null() ? nullptr : send_metrics_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->send_metrics.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null send_metrics in P2PSocketClient.SendComplete request");
  }
  network::P2PSendPacketMetrics param_send_metrics_;

  DISALLOW_COPY_AND_ASSIGN(P2PSocketClientProxy_SendComplete_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PSocketClientProxy_SendComplete_Message::kMessageTag = {};

void P2PSocketClientProxy::SendComplete(
    const network::P2PSendPacketMetrics& in_send_metrics) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::P2PSocketClient::SendComplete");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = P2PSocketClientProxy_SendComplete_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_send_metrics));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PSocketClient::Name_);
  message.set_method_name("SendComplete");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class P2PSocketClientProxy_IncomingTcpConnection_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PSocketClientProxy_IncomingTcpConnection_Message(
      uint32_t message_flags
      , const net::IPEndPoint& param_socket_address
      , P2PSocketPtr param_socket
      , P2PSocketClientRequest param_client
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PSocketClient_IncomingTcpConnection_Name,
          message_flags)
      , param_socket_address_(std::move(param_socket_address))
      , param_socket_(param_socket.PassInterface())
      , param_client_(std::move(param_client)){}
  ~P2PSocketClientProxy_IncomingTcpConnection_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      const net::IPEndPoint& param_socket_address, P2PSocketPtr param_socket, P2PSocketClientRequest param_client) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PSocketClientProxy_IncomingTcpConnection_Message>(
          kFlags
          , std::move(param_socket_address)
          , std::move(param_socket)
          , std::move(param_client)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PSocketClient_IncomingTcpConnection_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PSocketClient_IncomingTcpConnection_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->socket_address)::BaseType::BufferWriter
      socket_address_writer;
  mojo::internal::Serialize<::net::interfaces::IPEndPointDataView>(
      param_socket_address, buffer, &socket_address_writer, &serialization_context);
  params->socket_address.Set(
      socket_address_writer.is_null() ? nullptr : socket_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->socket_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null socket_address in P2PSocketClient.IncomingTcpConnection request");
  mojo::internal::Serialize<::network::mojom::P2PSocketPtrDataView>(
      param_socket, &params->socket, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->socket),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid socket in P2PSocketClient.IncomingTcpConnection request");
  mojo::internal::Serialize<::network::mojom::P2PSocketClientRequestDataView>(
      param_client, &params->client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in P2PSocketClient.IncomingTcpConnection request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PSocketClient* impl) {
    impl->IncomingTcpConnection(
        std::move(param_socket_address_),
        P2PSocketPtr(std::move(param_socket_)),
        std::move(param_client_));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PSocketClient_IncomingTcpConnection_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  typename decltype(params->socket_address)::BaseType::BufferWriter
      socket_address_writer;
  mojo::internal::Serialize<::net::interfaces::IPEndPointDataView>(
      param_socket_address_, buffer, &socket_address_writer, serialization_context);
  params->socket_address.Set(
      socket_address_writer.is_null() ? nullptr : socket_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->socket_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null socket_address in P2PSocketClient.IncomingTcpConnection request");
  mojo::internal::Serialize<::network::mojom::P2PSocketPtrDataView>(
      param_socket_, &params->socket, serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->socket),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid socket in P2PSocketClient.IncomingTcpConnection request");
  mojo::internal::Serialize<::network::mojom::P2PSocketClientRequestDataView>(
      param_client_, &params->client, serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in P2PSocketClient.IncomingTcpConnection request");
  }
  net::IPEndPoint param_socket_address_;
  P2PSocketPtrInfo param_socket_;
  P2PSocketClientRequest param_client_;

  DISALLOW_COPY_AND_ASSIGN(P2PSocketClientProxy_IncomingTcpConnection_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PSocketClientProxy_IncomingTcpConnection_Message::kMessageTag = {};

void P2PSocketClientProxy::IncomingTcpConnection(
    const net::IPEndPoint& in_socket_address, P2PSocketPtr in_socket, P2PSocketClientRequest in_client) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::P2PSocketClient::IncomingTcpConnection");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = P2PSocketClientProxy_IncomingTcpConnection_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_socket_address), std::move(in_socket), std::move(in_client));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PSocketClient::Name_);
  message.set_method_name("IncomingTcpConnection");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class P2PSocketClientProxy_DataReceived_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PSocketClientProxy_DataReceived_Message(
      uint32_t message_flags
      , const net::IPEndPoint& param_socket_address
      , const std::vector<int8_t>& param_data
      , base::TimeTicks param_timestamp
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PSocketClient_DataReceived_Name,
          message_flags)
      , param_socket_address_(std::move(param_socket_address))
      , param_data_(std::move(param_data))
      , param_timestamp_(std::move(param_timestamp)){}
  ~P2PSocketClientProxy_DataReceived_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      const net::IPEndPoint& param_socket_address, const std::vector<int8_t>& param_data, base::TimeTicks param_timestamp) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PSocketClientProxy_DataReceived_Message>(
          kFlags
          , std::move(param_socket_address)
          , std::move(param_data)
          , std::move(param_timestamp)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PSocketClient_DataReceived_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PSocketClient_DataReceived_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->socket_address)::BaseType::BufferWriter
      socket_address_writer;
  mojo::internal::Serialize<::net::interfaces::IPEndPointDataView>(
      param_socket_address, buffer, &socket_address_writer, &serialization_context);
  params->socket_address.Set(
      socket_address_writer.is_null() ? nullptr : socket_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->socket_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null socket_address in P2PSocketClient.DataReceived request");
  typename decltype(params->data)::BaseType::BufferWriter
      data_writer;
  const mojo::internal::ContainerValidateParams data_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<int8_t>>(
      param_data, buffer, &data_writer, &data_validate_params,
      &serialization_context);
  params->data.Set(
      data_writer.is_null() ? nullptr : data_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->data.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null data in P2PSocketClient.DataReceived request");
  typename decltype(params->timestamp)::BaseType::BufferWriter
      timestamp_writer;
  mojo::internal::Serialize<::mojo_base::mojom::TimeTicksDataView>(
      param_timestamp, buffer, &timestamp_writer, &serialization_context);
  params->timestamp.Set(
      timestamp_writer.is_null() ? nullptr : timestamp_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->timestamp.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null timestamp in P2PSocketClient.DataReceived request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PSocketClient* impl) {
    impl->DataReceived(
        std::move(param_socket_address_),
        std::move(param_data_),
        std::move(param_timestamp_));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PSocketClient_DataReceived_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  typename decltype(params->socket_address)::BaseType::BufferWriter
      socket_address_writer;
  mojo::internal::Serialize<::net::interfaces::IPEndPointDataView>(
      param_socket_address_, buffer, &socket_address_writer, serialization_context);
  params->socket_address.Set(
      socket_address_writer.is_null() ? nullptr : socket_address_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->socket_address.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null socket_address in P2PSocketClient.DataReceived request");
  typename decltype(params->data)::BaseType::BufferWriter
      data_writer;
  const mojo::internal::ContainerValidateParams data_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<int8_t>>(
      param_data_, buffer, &data_writer, &data_validate_params,
      serialization_context);
  params->data.Set(
      data_writer.is_null() ? nullptr : data_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->data.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null data in P2PSocketClient.DataReceived request");
  typename decltype(params->timestamp)::BaseType::BufferWriter
      timestamp_writer;
  mojo::internal::Serialize<::mojo_base::mojom::TimeTicksDataView>(
      param_timestamp_, buffer, &timestamp_writer, serialization_context);
  params->timestamp.Set(
      timestamp_writer.is_null() ? nullptr : timestamp_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->timestamp.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null timestamp in P2PSocketClient.DataReceived request");
  }
  net::IPEndPoint param_socket_address_;
  std::vector<int8_t> param_data_;
  base::TimeTicks param_timestamp_;

  DISALLOW_COPY_AND_ASSIGN(P2PSocketClientProxy_DataReceived_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PSocketClientProxy_DataReceived_Message::kMessageTag = {};

void P2PSocketClientProxy::DataReceived(
    const net::IPEndPoint& in_socket_address, const std::vector<int8_t>& in_data, base::TimeTicks in_timestamp) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::P2PSocketClient::DataReceived");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = P2PSocketClientProxy_DataReceived_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_socket_address), std::move(in_data), std::move(in_timestamp));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PSocketClient::Name_);
  message.set_method_name("DataReceived");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool P2PSocketClientStubDispatch::Accept(
    P2PSocketClient* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kP2PSocketClient_SocketCreated_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketClient::SocketCreated",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            P2PSocketClientProxy_SocketCreated_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::P2PSocketClient_SocketCreated_Params_Data* params =
          reinterpret_cast<internal::P2PSocketClient_SocketCreated_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      net::IPEndPoint p_local_address{};
      net::IPEndPoint p_remote_address{};
      P2PSocketClient_SocketCreated_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadLocalAddress(&p_local_address))
        success = false;
      if (!input_data_view.ReadRemoteAddress(&p_remote_address))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "P2PSocketClient::SocketCreated deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SocketCreated(
std::move(p_local_address), 
std::move(p_remote_address));
      return true;
    }
    case internal::kP2PSocketClient_SendComplete_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketClient::SendComplete",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            P2PSocketClientProxy_SendComplete_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::P2PSocketClient_SendComplete_Params_Data* params =
          reinterpret_cast<internal::P2PSocketClient_SendComplete_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      network::P2PSendPacketMetrics p_send_metrics{};
      P2PSocketClient_SendComplete_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadSendMetrics(&p_send_metrics))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "P2PSocketClient::SendComplete deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SendComplete(
std::move(p_send_metrics));
      return true;
    }
    case internal::kP2PSocketClient_IncomingTcpConnection_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketClient::IncomingTcpConnection",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            P2PSocketClientProxy_IncomingTcpConnection_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::P2PSocketClient_IncomingTcpConnection_Params_Data* params =
          reinterpret_cast<internal::P2PSocketClient_IncomingTcpConnection_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      net::IPEndPoint p_socket_address{};
      P2PSocketPtr p_socket{};
      P2PSocketClientRequest p_client{};
      P2PSocketClient_IncomingTcpConnection_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadSocketAddress(&p_socket_address))
        success = false;
      p_socket =
          input_data_view.TakeSocket<decltype(p_socket)>();
      p_client =
          input_data_view.TakeClient<decltype(p_client)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "P2PSocketClient::IncomingTcpConnection deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->IncomingTcpConnection(
std::move(p_socket_address), 
std::move(p_socket), 
std::move(p_client));
      return true;
    }
    case internal::kP2PSocketClient_DataReceived_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketClient::DataReceived",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            P2PSocketClientProxy_DataReceived_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::P2PSocketClient_DataReceived_Params_Data* params =
          reinterpret_cast<internal::P2PSocketClient_DataReceived_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      net::IPEndPoint p_socket_address{};
      std::vector<int8_t> p_data{};
      base::TimeTicks p_timestamp{};
      P2PSocketClient_DataReceived_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadSocketAddress(&p_socket_address))
        success = false;
      if (!input_data_view.ReadData(&p_data))
        success = false;
      if (!input_data_view.ReadTimestamp(&p_timestamp))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "P2PSocketClient::DataReceived deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DataReceived(
std::move(p_socket_address), 
std::move(p_data), 
std::move(p_timestamp));
      return true;
    }
  }
  return false;
}

// static
bool P2PSocketClientStubDispatch::AcceptWithResponder(
    P2PSocketClient* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kP2PSocketClient_SocketCreated_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketClient::SocketCreated",
               "message", message->name());
#endif
      break;
    }
    case internal::kP2PSocketClient_SendComplete_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketClient::SendComplete",
               "message", message->name());
#endif
      break;
    }
    case internal::kP2PSocketClient_IncomingTcpConnection_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketClient::IncomingTcpConnection",
               "message", message->name());
#endif
      break;
    }
    case internal::kP2PSocketClient_DataReceived_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PSocketClient::DataReceived",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool P2PSocketClientRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "P2PSocketClient RequestValidator");

  switch (message->header()->name) {
    case internal::kP2PSocketClient_SocketCreated_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PSocketClient_SocketCreated_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kP2PSocketClient_SendComplete_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PSocketClient_SendComplete_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kP2PSocketClient_IncomingTcpConnection_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PSocketClient_IncomingTcpConnection_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kP2PSocketClient_DataReceived_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PSocketClient_DataReceived_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

void P2PSocketClientInterceptorForTesting::SocketCreated(const net::IPEndPoint& local_address, const net::IPEndPoint& remote_address) {
  GetForwardingInterface()->SocketCreated(std::move(local_address), std::move(remote_address));
}
void P2PSocketClientInterceptorForTesting::SendComplete(const network::P2PSendPacketMetrics& send_metrics) {
  GetForwardingInterface()->SendComplete(std::move(send_metrics));
}
void P2PSocketClientInterceptorForTesting::IncomingTcpConnection(const net::IPEndPoint& socket_address, P2PSocketPtr socket, P2PSocketClientRequest client) {
  GetForwardingInterface()->IncomingTcpConnection(std::move(socket_address), std::move(socket), std::move(client));
}
void P2PSocketClientInterceptorForTesting::DataReceived(const net::IPEndPoint& socket_address, const std::vector<int8_t>& data, base::TimeTicks timestamp) {
  GetForwardingInterface()->DataReceived(std::move(socket_address), std::move(data), std::move(timestamp));
}
P2PSocketClientAsyncWaiter::P2PSocketClientAsyncWaiter(
    P2PSocketClient* proxy) : proxy_(proxy) {}

P2PSocketClientAsyncWaiter::~P2PSocketClientAsyncWaiter() = default;


}  // namespace mojom
}  // namespace network

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif