// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/network/public/mojom/proxy_lookup_client.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "services/network/public/mojom/proxy_lookup_client.mojom-shared-message-ids.h"
#include "services/proxy_resolver/public/cpp/proxy_resolver_mojom_traits.h"
namespace network {
namespace mojom {
const char ProxyLookupClient::Name_[] = "network.mojom.ProxyLookupClient";

ProxyLookupClientProxy::ProxyLookupClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}
class ProxyLookupClientProxy_OnProxyLookupComplete_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit ProxyLookupClientProxy_OnProxyLookupComplete_Message(
      uint32_t message_flags
      , const base::Optional<net::ProxyInfo>& param_proxy_info
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kProxyLookupClient_OnProxyLookupComplete_Name,
          message_flags)
      , param_proxy_info_(std::move(param_proxy_info)){}
  ~ProxyLookupClientProxy_OnProxyLookupComplete_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      const base::Optional<net::ProxyInfo>& param_proxy_info) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<ProxyLookupClientProxy_OnProxyLookupComplete_Message>(
          kFlags
          , std::move(param_proxy_info)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kProxyLookupClient_OnProxyLookupComplete_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::ProxyLookupClient_OnProxyLookupComplete_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->proxy_info)::BaseType::BufferWriter
      proxy_info_writer;
  mojo::internal::Serialize<::proxy_resolver::mojom::ProxyInfoDataView>(
      param_proxy_info, buffer, &proxy_info_writer, &serialization_context);
  params->proxy_info.Set(
      proxy_info_writer.is_null() ? nullptr : proxy_info_writer.data());
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(ProxyLookupClient* impl) {
    impl->OnProxyLookupComplete(
        std::move(param_proxy_info_));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::ProxyLookupClient_OnProxyLookupComplete_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  typename decltype(params->proxy_info)::BaseType::BufferWriter
      proxy_info_writer;
  mojo::internal::Serialize<::proxy_resolver::mojom::ProxyInfoDataView>(
      param_proxy_info_, buffer, &proxy_info_writer, serialization_context);
  params->proxy_info.Set(
      proxy_info_writer.is_null() ? nullptr : proxy_info_writer.data());
  }
  base::Optional<net::ProxyInfo> param_proxy_info_;

  DISALLOW_COPY_AND_ASSIGN(ProxyLookupClientProxy_OnProxyLookupComplete_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
ProxyLookupClientProxy_OnProxyLookupComplete_Message::kMessageTag = {};

void ProxyLookupClientProxy::OnProxyLookupComplete(
    const base::Optional<net::ProxyInfo>& in_proxy_info) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::ProxyLookupClient::OnProxyLookupComplete");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = ProxyLookupClientProxy_OnProxyLookupComplete_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_proxy_info));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(ProxyLookupClient::Name_);
  message.set_method_name("OnProxyLookupComplete");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool ProxyLookupClientStubDispatch::Accept(
    ProxyLookupClient* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kProxyLookupClient_OnProxyLookupComplete_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::ProxyLookupClient::OnProxyLookupComplete",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            ProxyLookupClientProxy_OnProxyLookupComplete_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::ProxyLookupClient_OnProxyLookupComplete_Params_Data* params =
          reinterpret_cast<internal::ProxyLookupClient_OnProxyLookupComplete_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      base::Optional<net::ProxyInfo> p_proxy_info{};
      ProxyLookupClient_OnProxyLookupComplete_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadProxyInfo(&p_proxy_info))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ProxyLookupClient::OnProxyLookupComplete deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->OnProxyLookupComplete(
std::move(p_proxy_info));
      return true;
    }
  }
  return false;
}

// static
bool ProxyLookupClientStubDispatch::AcceptWithResponder(
    ProxyLookupClient* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kProxyLookupClient_OnProxyLookupComplete_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::ProxyLookupClient::OnProxyLookupComplete",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool ProxyLookupClientRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "ProxyLookupClient RequestValidator");

  switch (message->header()->name) {
    case internal::kProxyLookupClient_OnProxyLookupComplete_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ProxyLookupClient_OnProxyLookupComplete_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

void ProxyLookupClientInterceptorForTesting::OnProxyLookupComplete(const base::Optional<net::ProxyInfo>& proxy_info) {
  GetForwardingInterface()->OnProxyLookupComplete(std::move(proxy_info));
}
ProxyLookupClientAsyncWaiter::ProxyLookupClientAsyncWaiter(
    ProxyLookupClient* proxy) : proxy_(proxy) {}

ProxyLookupClientAsyncWaiter::~ProxyLookupClientAsyncWaiter() = default;


}  // namespace mojom
}  // namespace network

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif