// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_VIEWS_BRIDGE_MAC_MOJO_BRIDGED_NATIVE_WIDGET_MOJOM_SHARED_INTERNAL_H_
#define UI_VIEWS_BRIDGE_MAC_MOJO_BRIDGED_NATIVE_WIDGET_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/string16.mojom-shared-internal.h"
#include "ui/base/mojo/ui_base_types.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "ui/gfx/mojo/ca_layer_params.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace views_bridge_mac {
namespace mojom {
namespace internal {
class BridgedNativeWidgetInitParams_Data;

struct WindowVisibilityState_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  BridgedNativeWidgetInitParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidgetInitParams_Data));
      new (data()) BridgedNativeWidgetInitParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidgetInitParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidgetInitParams_Data>(index_);
    }
    BridgedNativeWidgetInitParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t modal_type;
  uint8_t is_translucent : 1;
  uint8_t has_window_server_shadow : 1;
  uint8_t force_into_collection_cycle : 1;
  uint8_t padfinal_[3];

 private:
  BridgedNativeWidgetInitParams_Data();
  ~BridgedNativeWidgetInitParams_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidgetInitParams_Data) == 16,
              "Bad sizeof(BridgedNativeWidgetInitParams_Data)");
// Used by BridgedNativeWidgetInitParams::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct BridgedNativeWidgetInitParams_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  BridgedNativeWidgetInitParams_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~BridgedNativeWidgetInitParams_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    BridgedNativeWidgetInitParams_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    BridgedNativeWidgetInitParams_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  BridgedNativeWidget_InitWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_InitWindow_Params_Data));
      new (data()) BridgedNativeWidget_InitWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_InitWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_InitWindow_Params_Data>(index_);
    }
    BridgedNativeWidget_InitWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::BridgedNativeWidgetInitParams_Data> params;

 private:
  BridgedNativeWidget_InitWindow_Params_Data();
  ~BridgedNativeWidget_InitWindow_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_InitWindow_Params_Data) == 16,
              "Bad sizeof(BridgedNativeWidget_InitWindow_Params_Data)");
class  BridgedNativeWidget_InitCompositorView_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_InitCompositorView_Params_Data));
      new (data()) BridgedNativeWidget_InitCompositorView_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_InitCompositorView_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_InitCompositorView_Params_Data>(index_);
    }
    BridgedNativeWidget_InitCompositorView_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BridgedNativeWidget_InitCompositorView_Params_Data();
  ~BridgedNativeWidget_InitCompositorView_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_InitCompositorView_Params_Data) == 8,
              "Bad sizeof(BridgedNativeWidget_InitCompositorView_Params_Data)");
class  BridgedNativeWidget_CreateContentView_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_CreateContentView_Params_Data));
      new (data()) BridgedNativeWidget_CreateContentView_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_CreateContentView_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_CreateContentView_Params_Data>(index_);
    }
    BridgedNativeWidget_CreateContentView_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> bounds;

 private:
  BridgedNativeWidget_CreateContentView_Params_Data();
  ~BridgedNativeWidget_CreateContentView_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_CreateContentView_Params_Data) == 16,
              "Bad sizeof(BridgedNativeWidget_CreateContentView_Params_Data)");
class  BridgedNativeWidget_DestroyContentView_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_DestroyContentView_Params_Data));
      new (data()) BridgedNativeWidget_DestroyContentView_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_DestroyContentView_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_DestroyContentView_Params_Data>(index_);
    }
    BridgedNativeWidget_DestroyContentView_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BridgedNativeWidget_DestroyContentView_Params_Data();
  ~BridgedNativeWidget_DestroyContentView_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_DestroyContentView_Params_Data) == 8,
              "Bad sizeof(BridgedNativeWidget_DestroyContentView_Params_Data)");
class  BridgedNativeWidget_CloseWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_CloseWindow_Params_Data));
      new (data()) BridgedNativeWidget_CloseWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_CloseWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_CloseWindow_Params_Data>(index_);
    }
    BridgedNativeWidget_CloseWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BridgedNativeWidget_CloseWindow_Params_Data();
  ~BridgedNativeWidget_CloseWindow_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_CloseWindow_Params_Data) == 8,
              "Bad sizeof(BridgedNativeWidget_CloseWindow_Params_Data)");
class  BridgedNativeWidget_CloseWindowNow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_CloseWindowNow_Params_Data));
      new (data()) BridgedNativeWidget_CloseWindowNow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_CloseWindowNow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_CloseWindowNow_Params_Data>(index_);
    }
    BridgedNativeWidget_CloseWindowNow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BridgedNativeWidget_CloseWindowNow_Params_Data();
  ~BridgedNativeWidget_CloseWindowNow_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_CloseWindowNow_Params_Data) == 8,
              "Bad sizeof(BridgedNativeWidget_CloseWindowNow_Params_Data)");
class  BridgedNativeWidget_SetInitialBounds_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_SetInitialBounds_Params_Data));
      new (data()) BridgedNativeWidget_SetInitialBounds_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_SetInitialBounds_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_SetInitialBounds_Params_Data>(index_);
    }
    BridgedNativeWidget_SetInitialBounds_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> new_bounds;
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> minimum_content_size;
  mojo::internal::Pointer<::gfx::mojom::internal::Vector2d_Data> parent_offset;

 private:
  BridgedNativeWidget_SetInitialBounds_Params_Data();
  ~BridgedNativeWidget_SetInitialBounds_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_SetInitialBounds_Params_Data) == 32,
              "Bad sizeof(BridgedNativeWidget_SetInitialBounds_Params_Data)");
class  BridgedNativeWidget_SetBounds_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_SetBounds_Params_Data));
      new (data()) BridgedNativeWidget_SetBounds_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_SetBounds_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_SetBounds_Params_Data>(index_);
    }
    BridgedNativeWidget_SetBounds_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> new_bounds;
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> minimum_content_size;

 private:
  BridgedNativeWidget_SetBounds_Params_Data();
  ~BridgedNativeWidget_SetBounds_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_SetBounds_Params_Data) == 24,
              "Bad sizeof(BridgedNativeWidget_SetBounds_Params_Data)");
class  BridgedNativeWidget_SetVisibilityState_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_SetVisibilityState_Params_Data));
      new (data()) BridgedNativeWidget_SetVisibilityState_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_SetVisibilityState_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_SetVisibilityState_Params_Data>(index_);
    }
    BridgedNativeWidget_SetVisibilityState_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t new_state;
  uint8_t padfinal_[4];

 private:
  BridgedNativeWidget_SetVisibilityState_Params_Data();
  ~BridgedNativeWidget_SetVisibilityState_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_SetVisibilityState_Params_Data) == 16,
              "Bad sizeof(BridgedNativeWidget_SetVisibilityState_Params_Data)");
class  BridgedNativeWidget_SetVisibleOnAllSpaces_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_SetVisibleOnAllSpaces_Params_Data));
      new (data()) BridgedNativeWidget_SetVisibleOnAllSpaces_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_SetVisibleOnAllSpaces_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_SetVisibleOnAllSpaces_Params_Data>(index_);
    }
    BridgedNativeWidget_SetVisibleOnAllSpaces_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t always_visible : 1;
  uint8_t padfinal_[7];

 private:
  BridgedNativeWidget_SetVisibleOnAllSpaces_Params_Data();
  ~BridgedNativeWidget_SetVisibleOnAllSpaces_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_SetVisibleOnAllSpaces_Params_Data) == 16,
              "Bad sizeof(BridgedNativeWidget_SetVisibleOnAllSpaces_Params_Data)");
class  BridgedNativeWidget_SetFullscreen_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_SetFullscreen_Params_Data));
      new (data()) BridgedNativeWidget_SetFullscreen_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_SetFullscreen_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_SetFullscreen_Params_Data>(index_);
    }
    BridgedNativeWidget_SetFullscreen_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t fullscreen : 1;
  uint8_t padfinal_[7];

 private:
  BridgedNativeWidget_SetFullscreen_Params_Data();
  ~BridgedNativeWidget_SetFullscreen_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_SetFullscreen_Params_Data) == 16,
              "Bad sizeof(BridgedNativeWidget_SetFullscreen_Params_Data)");
class  BridgedNativeWidget_SetMiniaturized_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_SetMiniaturized_Params_Data));
      new (data()) BridgedNativeWidget_SetMiniaturized_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_SetMiniaturized_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_SetMiniaturized_Params_Data>(index_);
    }
    BridgedNativeWidget_SetMiniaturized_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t miniaturized : 1;
  uint8_t padfinal_[7];

 private:
  BridgedNativeWidget_SetMiniaturized_Params_Data();
  ~BridgedNativeWidget_SetMiniaturized_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_SetMiniaturized_Params_Data) == 16,
              "Bad sizeof(BridgedNativeWidget_SetMiniaturized_Params_Data)");
class  BridgedNativeWidget_SetSizeConstraints_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_SetSizeConstraints_Params_Data));
      new (data()) BridgedNativeWidget_SetSizeConstraints_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_SetSizeConstraints_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_SetSizeConstraints_Params_Data>(index_);
    }
    BridgedNativeWidget_SetSizeConstraints_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> min_size;
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> max_size;
  uint8_t is_resizable : 1;
  uint8_t is_maximizable : 1;
  uint8_t padfinal_[7];

 private:
  BridgedNativeWidget_SetSizeConstraints_Params_Data();
  ~BridgedNativeWidget_SetSizeConstraints_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_SetSizeConstraints_Params_Data) == 32,
              "Bad sizeof(BridgedNativeWidget_SetSizeConstraints_Params_Data)");
class  BridgedNativeWidget_SetOpacity_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_SetOpacity_Params_Data));
      new (data()) BridgedNativeWidget_SetOpacity_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_SetOpacity_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_SetOpacity_Params_Data>(index_);
    }
    BridgedNativeWidget_SetOpacity_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  float opacity;
  uint8_t padfinal_[4];

 private:
  BridgedNativeWidget_SetOpacity_Params_Data();
  ~BridgedNativeWidget_SetOpacity_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_SetOpacity_Params_Data) == 16,
              "Bad sizeof(BridgedNativeWidget_SetOpacity_Params_Data)");
class  BridgedNativeWidget_SetContentAspectRatio_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_SetContentAspectRatio_Params_Data));
      new (data()) BridgedNativeWidget_SetContentAspectRatio_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_SetContentAspectRatio_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_SetContentAspectRatio_Params_Data>(index_);
    }
    BridgedNativeWidget_SetContentAspectRatio_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::SizeF_Data> aspect_ratio;

 private:
  BridgedNativeWidget_SetContentAspectRatio_Params_Data();
  ~BridgedNativeWidget_SetContentAspectRatio_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_SetContentAspectRatio_Params_Data) == 16,
              "Bad sizeof(BridgedNativeWidget_SetContentAspectRatio_Params_Data)");
class  BridgedNativeWidget_SetCALayerParams_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_SetCALayerParams_Params_Data));
      new (data()) BridgedNativeWidget_SetCALayerParams_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_SetCALayerParams_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_SetCALayerParams_Params_Data>(index_);
    }
    BridgedNativeWidget_SetCALayerParams_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::CALayerParams_Data> ca_layer_params;

 private:
  BridgedNativeWidget_SetCALayerParams_Params_Data();
  ~BridgedNativeWidget_SetCALayerParams_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_SetCALayerParams_Params_Data) == 16,
              "Bad sizeof(BridgedNativeWidget_SetCALayerParams_Params_Data)");
class  BridgedNativeWidget_SetWindowTitle_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_SetWindowTitle_Params_Data));
      new (data()) BridgedNativeWidget_SetWindowTitle_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_SetWindowTitle_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_SetWindowTitle_Params_Data>(index_);
    }
    BridgedNativeWidget_SetWindowTitle_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::String16_Data> title;

 private:
  BridgedNativeWidget_SetWindowTitle_Params_Data();
  ~BridgedNativeWidget_SetWindowTitle_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_SetWindowTitle_Params_Data) == 16,
              "Bad sizeof(BridgedNativeWidget_SetWindowTitle_Params_Data)");
class  BridgedNativeWidget_MakeFirstResponder_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_MakeFirstResponder_Params_Data));
      new (data()) BridgedNativeWidget_MakeFirstResponder_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_MakeFirstResponder_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_MakeFirstResponder_Params_Data>(index_);
    }
    BridgedNativeWidget_MakeFirstResponder_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BridgedNativeWidget_MakeFirstResponder_Params_Data();
  ~BridgedNativeWidget_MakeFirstResponder_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_MakeFirstResponder_Params_Data) == 8,
              "Bad sizeof(BridgedNativeWidget_MakeFirstResponder_Params_Data)");
class  BridgedNativeWidget_ClearTouchBar_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_ClearTouchBar_Params_Data));
      new (data()) BridgedNativeWidget_ClearTouchBar_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_ClearTouchBar_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_ClearTouchBar_Params_Data>(index_);
    }
    BridgedNativeWidget_ClearTouchBar_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BridgedNativeWidget_ClearTouchBar_Params_Data();
  ~BridgedNativeWidget_ClearTouchBar_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_ClearTouchBar_Params_Data) == 8,
              "Bad sizeof(BridgedNativeWidget_ClearTouchBar_Params_Data)");
class  BridgedNativeWidget_AcquireCapture_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_AcquireCapture_Params_Data));
      new (data()) BridgedNativeWidget_AcquireCapture_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_AcquireCapture_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_AcquireCapture_Params_Data>(index_);
    }
    BridgedNativeWidget_AcquireCapture_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BridgedNativeWidget_AcquireCapture_Params_Data();
  ~BridgedNativeWidget_AcquireCapture_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_AcquireCapture_Params_Data) == 8,
              "Bad sizeof(BridgedNativeWidget_AcquireCapture_Params_Data)");
class  BridgedNativeWidget_ReleaseCapture_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BridgedNativeWidget_ReleaseCapture_Params_Data));
      new (data()) BridgedNativeWidget_ReleaseCapture_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BridgedNativeWidget_ReleaseCapture_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BridgedNativeWidget_ReleaseCapture_Params_Data>(index_);
    }
    BridgedNativeWidget_ReleaseCapture_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BridgedNativeWidget_ReleaseCapture_Params_Data();
  ~BridgedNativeWidget_ReleaseCapture_Params_Data() = delete;
};
static_assert(sizeof(BridgedNativeWidget_ReleaseCapture_Params_Data) == 8,
              "Bad sizeof(BridgedNativeWidget_ReleaseCapture_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace views_bridge_mac

#endif  // UI_VIEWS_BRIDGE_MAC_MOJO_BRIDGED_NATIVE_WIDGET_MOJOM_SHARED_INTERNAL_H_