// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "ui/views_bridge_mac/mojo/bridged_native_widget.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "ui/views_bridge_mac/mojo/bridged_native_widget.mojom-shared-message-ids.h"
#include "mojo/public/cpp/base/string16_mojom_traits.h"
#include "ui/base/mojo/ui_base_types_struct_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "ui/gfx/mojo/ca_layer_params_struct_traits.h"
namespace views_bridge_mac {
namespace mojom {
BridgedNativeWidgetInitParams::BridgedNativeWidgetInitParams()
    : modal_type(),
      is_translucent(),
      has_window_server_shadow(),
      force_into_collection_cycle() {}

BridgedNativeWidgetInitParams::BridgedNativeWidgetInitParams(
    ui::ModalType modal_type_in,
    bool is_translucent_in,
    bool has_window_server_shadow_in,
    bool force_into_collection_cycle_in)
    : modal_type(std::move(modal_type_in)),
      is_translucent(std::move(is_translucent_in)),
      has_window_server_shadow(std::move(has_window_server_shadow_in)),
      force_into_collection_cycle(std::move(force_into_collection_cycle_in)) {}

BridgedNativeWidgetInitParams::~BridgedNativeWidgetInitParams() = default;

bool BridgedNativeWidgetInitParams::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char BridgedNativeWidget::Name_[] = "views_bridge_mac.mojom.BridgedNativeWidget";

BridgedNativeWidgetProxy::BridgedNativeWidgetProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void BridgedNativeWidgetProxy::InitWindow(
    BridgedNativeWidgetInitParamsPtr in_params) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::InitWindow");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_InitWindow_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_InitWindow_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->params)::BaseType::BufferWriter
      params_writer;
  mojo::internal::Serialize<::views_bridge_mac::mojom::BridgedNativeWidgetInitParamsDataView>(
      in_params, buffer, &params_writer, &serialization_context);
  params->params.Set(
      params_writer.is_null() ? nullptr : params_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->params.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null params in BridgedNativeWidget.InitWindow request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("InitWindow");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::InitCompositorView(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::InitCompositorView");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_InitCompositorView_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_InitCompositorView_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("InitCompositorView");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::CreateContentView(
    const gfx::Rect& in_bounds) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::CreateContentView");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_CreateContentView_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_CreateContentView_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->bounds)::BaseType::BufferWriter
      bounds_writer;
  mojo::internal::Serialize<::gfx::mojom::RectDataView>(
      in_bounds, buffer, &bounds_writer, &serialization_context);
  params->bounds.Set(
      bounds_writer.is_null() ? nullptr : bounds_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->bounds.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null bounds in BridgedNativeWidget.CreateContentView request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("CreateContentView");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::DestroyContentView(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::DestroyContentView");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_DestroyContentView_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_DestroyContentView_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("DestroyContentView");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::CloseWindow(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::CloseWindow");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_CloseWindow_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_CloseWindow_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("CloseWindow");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::CloseWindowNow(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::CloseWindowNow");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_CloseWindowNow_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_CloseWindowNow_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("CloseWindowNow");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::SetInitialBounds(
    const gfx::Rect& in_new_bounds, const gfx::Size& in_minimum_content_size, const gfx::Vector2d& in_parent_offset) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::SetInitialBounds");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_SetInitialBounds_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_SetInitialBounds_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->new_bounds)::BaseType::BufferWriter
      new_bounds_writer;
  mojo::internal::Serialize<::gfx::mojom::RectDataView>(
      in_new_bounds, buffer, &new_bounds_writer, &serialization_context);
  params->new_bounds.Set(
      new_bounds_writer.is_null() ? nullptr : new_bounds_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->new_bounds.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null new_bounds in BridgedNativeWidget.SetInitialBounds request");
  typename decltype(params->minimum_content_size)::BaseType::BufferWriter
      minimum_content_size_writer;
  mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
      in_minimum_content_size, buffer, &minimum_content_size_writer, &serialization_context);
  params->minimum_content_size.Set(
      minimum_content_size_writer.is_null() ? nullptr : minimum_content_size_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->minimum_content_size.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null minimum_content_size in BridgedNativeWidget.SetInitialBounds request");
  typename decltype(params->parent_offset)::BaseType::BufferWriter
      parent_offset_writer;
  mojo::internal::Serialize<::gfx::mojom::Vector2dDataView>(
      in_parent_offset, buffer, &parent_offset_writer, &serialization_context);
  params->parent_offset.Set(
      parent_offset_writer.is_null() ? nullptr : parent_offset_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->parent_offset.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null parent_offset in BridgedNativeWidget.SetInitialBounds request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("SetInitialBounds");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::SetBounds(
    const gfx::Rect& in_new_bounds, const gfx::Size& in_minimum_content_size) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::SetBounds");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_SetBounds_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_SetBounds_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->new_bounds)::BaseType::BufferWriter
      new_bounds_writer;
  mojo::internal::Serialize<::gfx::mojom::RectDataView>(
      in_new_bounds, buffer, &new_bounds_writer, &serialization_context);
  params->new_bounds.Set(
      new_bounds_writer.is_null() ? nullptr : new_bounds_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->new_bounds.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null new_bounds in BridgedNativeWidget.SetBounds request");
  typename decltype(params->minimum_content_size)::BaseType::BufferWriter
      minimum_content_size_writer;
  mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
      in_minimum_content_size, buffer, &minimum_content_size_writer, &serialization_context);
  params->minimum_content_size.Set(
      minimum_content_size_writer.is_null() ? nullptr : minimum_content_size_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->minimum_content_size.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null minimum_content_size in BridgedNativeWidget.SetBounds request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("SetBounds");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::SetVisibilityState(
    WindowVisibilityState in_new_state) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::SetVisibilityState");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_SetVisibilityState_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_SetVisibilityState_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::views_bridge_mac::mojom::WindowVisibilityState>(
      in_new_state, &params->new_state);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("SetVisibilityState");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::SetVisibleOnAllSpaces(
    bool in_always_visible) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::SetVisibleOnAllSpaces");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_SetVisibleOnAllSpaces_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_SetVisibleOnAllSpaces_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->always_visible = in_always_visible;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("SetVisibleOnAllSpaces");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::SetFullscreen(
    bool in_fullscreen) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::SetFullscreen");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_SetFullscreen_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_SetFullscreen_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->fullscreen = in_fullscreen;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("SetFullscreen");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::SetMiniaturized(
    bool in_miniaturized) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::SetMiniaturized");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_SetMiniaturized_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_SetMiniaturized_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->miniaturized = in_miniaturized;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("SetMiniaturized");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::SetSizeConstraints(
    const gfx::Size& in_min_size, const gfx::Size& in_max_size, bool in_is_resizable, bool in_is_maximizable) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::SetSizeConstraints");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_SetSizeConstraints_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_SetSizeConstraints_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->min_size)::BaseType::BufferWriter
      min_size_writer;
  mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
      in_min_size, buffer, &min_size_writer, &serialization_context);
  params->min_size.Set(
      min_size_writer.is_null() ? nullptr : min_size_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->min_size.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null min_size in BridgedNativeWidget.SetSizeConstraints request");
  typename decltype(params->max_size)::BaseType::BufferWriter
      max_size_writer;
  mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
      in_max_size, buffer, &max_size_writer, &serialization_context);
  params->max_size.Set(
      max_size_writer.is_null() ? nullptr : max_size_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->max_size.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null max_size in BridgedNativeWidget.SetSizeConstraints request");
  params->is_resizable = in_is_resizable;
  params->is_maximizable = in_is_maximizable;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("SetSizeConstraints");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::SetOpacity(
    float in_opacity) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::SetOpacity");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_SetOpacity_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_SetOpacity_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->opacity = in_opacity;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("SetOpacity");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::SetContentAspectRatio(
    const gfx::SizeF& in_aspect_ratio) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::SetContentAspectRatio");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_SetContentAspectRatio_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_SetContentAspectRatio_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->aspect_ratio)::BaseType::BufferWriter
      aspect_ratio_writer;
  mojo::internal::Serialize<::gfx::mojom::SizeFDataView>(
      in_aspect_ratio, buffer, &aspect_ratio_writer, &serialization_context);
  params->aspect_ratio.Set(
      aspect_ratio_writer.is_null() ? nullptr : aspect_ratio_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->aspect_ratio.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null aspect_ratio in BridgedNativeWidget.SetContentAspectRatio request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("SetContentAspectRatio");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::SetCALayerParams(
    const gfx::CALayerParams& in_ca_layer_params) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::SetCALayerParams");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_SetCALayerParams_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_SetCALayerParams_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->ca_layer_params)::BaseType::BufferWriter
      ca_layer_params_writer;
  mojo::internal::Serialize<::gfx::mojom::CALayerParamsDataView>(
      in_ca_layer_params, buffer, &ca_layer_params_writer, &serialization_context);
  params->ca_layer_params.Set(
      ca_layer_params_writer.is_null() ? nullptr : ca_layer_params_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->ca_layer_params.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null ca_layer_params in BridgedNativeWidget.SetCALayerParams request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("SetCALayerParams");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::SetWindowTitle(
    const base::string16& in_title) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::SetWindowTitle");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_SetWindowTitle_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_SetWindowTitle_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->title)::BaseType::BufferWriter
      title_writer;
  mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
      in_title, buffer, &title_writer, &serialization_context);
  params->title.Set(
      title_writer.is_null() ? nullptr : title_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->title.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null title in BridgedNativeWidget.SetWindowTitle request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("SetWindowTitle");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::MakeFirstResponder(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::MakeFirstResponder");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_MakeFirstResponder_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_MakeFirstResponder_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("MakeFirstResponder");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::ClearTouchBar(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::ClearTouchBar");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_ClearTouchBar_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_ClearTouchBar_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("ClearTouchBar");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::AcquireCapture(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::AcquireCapture");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_AcquireCapture_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_AcquireCapture_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("AcquireCapture");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void BridgedNativeWidgetProxy::ReleaseCapture(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "views_bridge_mac::mojom::BridgedNativeWidget::ReleaseCapture");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kBridgedNativeWidget_ReleaseCapture_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::views_bridge_mac::mojom::internal::BridgedNativeWidget_ReleaseCapture_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(BridgedNativeWidget::Name_);
  message.set_method_name("ReleaseCapture");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool BridgedNativeWidgetStubDispatch::Accept(
    BridgedNativeWidget* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kBridgedNativeWidget_InitWindow_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::InitWindow",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_InitWindow_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_InitWindow_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      BridgedNativeWidgetInitParamsPtr p_params{};
      BridgedNativeWidget_InitWindow_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadParams(&p_params))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::InitWindow deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->InitWindow(
std::move(p_params));
      return true;
    }
    case internal::kBridgedNativeWidget_InitCompositorView_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::InitCompositorView",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_InitCompositorView_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_InitCompositorView_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      BridgedNativeWidget_InitCompositorView_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::InitCompositorView deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->InitCompositorView();
      return true;
    }
    case internal::kBridgedNativeWidget_CreateContentView_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::CreateContentView",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_CreateContentView_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_CreateContentView_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      gfx::Rect p_bounds{};
      BridgedNativeWidget_CreateContentView_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadBounds(&p_bounds))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::CreateContentView deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateContentView(
std::move(p_bounds));
      return true;
    }
    case internal::kBridgedNativeWidget_DestroyContentView_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::DestroyContentView",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_DestroyContentView_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_DestroyContentView_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      BridgedNativeWidget_DestroyContentView_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::DestroyContentView deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DestroyContentView();
      return true;
    }
    case internal::kBridgedNativeWidget_CloseWindow_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::CloseWindow",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_CloseWindow_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_CloseWindow_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      BridgedNativeWidget_CloseWindow_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::CloseWindow deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CloseWindow();
      return true;
    }
    case internal::kBridgedNativeWidget_CloseWindowNow_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::CloseWindowNow",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_CloseWindowNow_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_CloseWindowNow_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      BridgedNativeWidget_CloseWindowNow_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::CloseWindowNow deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CloseWindowNow();
      return true;
    }
    case internal::kBridgedNativeWidget_SetInitialBounds_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetInitialBounds",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_SetInitialBounds_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_SetInitialBounds_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      gfx::Rect p_new_bounds{};
      gfx::Size p_minimum_content_size{};
      gfx::Vector2d p_parent_offset{};
      BridgedNativeWidget_SetInitialBounds_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadNewBounds(&p_new_bounds))
        success = false;
      if (!input_data_view.ReadMinimumContentSize(&p_minimum_content_size))
        success = false;
      if (!input_data_view.ReadParentOffset(&p_parent_offset))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::SetInitialBounds deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetInitialBounds(
std::move(p_new_bounds), 
std::move(p_minimum_content_size), 
std::move(p_parent_offset));
      return true;
    }
    case internal::kBridgedNativeWidget_SetBounds_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetBounds",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_SetBounds_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_SetBounds_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      gfx::Rect p_new_bounds{};
      gfx::Size p_minimum_content_size{};
      BridgedNativeWidget_SetBounds_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadNewBounds(&p_new_bounds))
        success = false;
      if (!input_data_view.ReadMinimumContentSize(&p_minimum_content_size))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::SetBounds deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetBounds(
std::move(p_new_bounds), 
std::move(p_minimum_content_size));
      return true;
    }
    case internal::kBridgedNativeWidget_SetVisibilityState_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetVisibilityState",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_SetVisibilityState_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_SetVisibilityState_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      WindowVisibilityState p_new_state{};
      BridgedNativeWidget_SetVisibilityState_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadNewState(&p_new_state))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::SetVisibilityState deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetVisibilityState(
std::move(p_new_state));
      return true;
    }
    case internal::kBridgedNativeWidget_SetVisibleOnAllSpaces_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetVisibleOnAllSpaces",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_SetVisibleOnAllSpaces_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_SetVisibleOnAllSpaces_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      bool p_always_visible{};
      BridgedNativeWidget_SetVisibleOnAllSpaces_ParamsDataView input_data_view(params, &serialization_context);
      
      p_always_visible = input_data_view.always_visible();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::SetVisibleOnAllSpaces deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetVisibleOnAllSpaces(
std::move(p_always_visible));
      return true;
    }
    case internal::kBridgedNativeWidget_SetFullscreen_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetFullscreen",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_SetFullscreen_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_SetFullscreen_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      bool p_fullscreen{};
      BridgedNativeWidget_SetFullscreen_ParamsDataView input_data_view(params, &serialization_context);
      
      p_fullscreen = input_data_view.fullscreen();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::SetFullscreen deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetFullscreen(
std::move(p_fullscreen));
      return true;
    }
    case internal::kBridgedNativeWidget_SetMiniaturized_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetMiniaturized",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_SetMiniaturized_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_SetMiniaturized_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      bool p_miniaturized{};
      BridgedNativeWidget_SetMiniaturized_ParamsDataView input_data_view(params, &serialization_context);
      
      p_miniaturized = input_data_view.miniaturized();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::SetMiniaturized deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetMiniaturized(
std::move(p_miniaturized));
      return true;
    }
    case internal::kBridgedNativeWidget_SetSizeConstraints_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetSizeConstraints",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_SetSizeConstraints_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_SetSizeConstraints_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      gfx::Size p_min_size{};
      gfx::Size p_max_size{};
      bool p_is_resizable{};
      bool p_is_maximizable{};
      BridgedNativeWidget_SetSizeConstraints_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadMinSize(&p_min_size))
        success = false;
      if (!input_data_view.ReadMaxSize(&p_max_size))
        success = false;
      p_is_resizable = input_data_view.is_resizable();
      p_is_maximizable = input_data_view.is_maximizable();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::SetSizeConstraints deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetSizeConstraints(
std::move(p_min_size), 
std::move(p_max_size), 
std::move(p_is_resizable), 
std::move(p_is_maximizable));
      return true;
    }
    case internal::kBridgedNativeWidget_SetOpacity_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetOpacity",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_SetOpacity_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_SetOpacity_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      float p_opacity{};
      BridgedNativeWidget_SetOpacity_ParamsDataView input_data_view(params, &serialization_context);
      
      p_opacity = input_data_view.opacity();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::SetOpacity deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetOpacity(
std::move(p_opacity));
      return true;
    }
    case internal::kBridgedNativeWidget_SetContentAspectRatio_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetContentAspectRatio",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_SetContentAspectRatio_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_SetContentAspectRatio_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      gfx::SizeF p_aspect_ratio{};
      BridgedNativeWidget_SetContentAspectRatio_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadAspectRatio(&p_aspect_ratio))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::SetContentAspectRatio deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetContentAspectRatio(
std::move(p_aspect_ratio));
      return true;
    }
    case internal::kBridgedNativeWidget_SetCALayerParams_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetCALayerParams",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_SetCALayerParams_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_SetCALayerParams_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      gfx::CALayerParams p_ca_layer_params{};
      BridgedNativeWidget_SetCALayerParams_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadCaLayerParams(&p_ca_layer_params))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::SetCALayerParams deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetCALayerParams(
std::move(p_ca_layer_params));
      return true;
    }
    case internal::kBridgedNativeWidget_SetWindowTitle_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetWindowTitle",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_SetWindowTitle_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_SetWindowTitle_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      base::string16 p_title{};
      BridgedNativeWidget_SetWindowTitle_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadTitle(&p_title))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::SetWindowTitle deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetWindowTitle(
std::move(p_title));
      return true;
    }
    case internal::kBridgedNativeWidget_MakeFirstResponder_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::MakeFirstResponder",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_MakeFirstResponder_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_MakeFirstResponder_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      BridgedNativeWidget_MakeFirstResponder_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::MakeFirstResponder deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->MakeFirstResponder();
      return true;
    }
    case internal::kBridgedNativeWidget_ClearTouchBar_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::ClearTouchBar",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_ClearTouchBar_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_ClearTouchBar_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      BridgedNativeWidget_ClearTouchBar_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::ClearTouchBar deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->ClearTouchBar();
      return true;
    }
    case internal::kBridgedNativeWidget_AcquireCapture_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::AcquireCapture",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_AcquireCapture_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_AcquireCapture_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      BridgedNativeWidget_AcquireCapture_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::AcquireCapture deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->AcquireCapture();
      return true;
    }
    case internal::kBridgedNativeWidget_ReleaseCapture_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::ReleaseCapture",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::BridgedNativeWidget_ReleaseCapture_Params_Data* params =
          reinterpret_cast<internal::BridgedNativeWidget_ReleaseCapture_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      BridgedNativeWidget_ReleaseCapture_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "BridgedNativeWidget::ReleaseCapture deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->ReleaseCapture();
      return true;
    }
  }
  return false;
}

// static
bool BridgedNativeWidgetStubDispatch::AcceptWithResponder(
    BridgedNativeWidget* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kBridgedNativeWidget_InitWindow_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::InitWindow",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_InitCompositorView_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::InitCompositorView",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_CreateContentView_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::CreateContentView",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_DestroyContentView_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::DestroyContentView",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_CloseWindow_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::CloseWindow",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_CloseWindowNow_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::CloseWindowNow",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_SetInitialBounds_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetInitialBounds",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_SetBounds_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetBounds",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_SetVisibilityState_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetVisibilityState",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_SetVisibleOnAllSpaces_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetVisibleOnAllSpaces",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_SetFullscreen_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetFullscreen",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_SetMiniaturized_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetMiniaturized",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_SetSizeConstraints_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetSizeConstraints",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_SetOpacity_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetOpacity",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_SetContentAspectRatio_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetContentAspectRatio",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_SetCALayerParams_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetCALayerParams",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_SetWindowTitle_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::SetWindowTitle",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_MakeFirstResponder_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::MakeFirstResponder",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_ClearTouchBar_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::ClearTouchBar",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_AcquireCapture_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::AcquireCapture",
               "message", message->name());
#endif
      break;
    }
    case internal::kBridgedNativeWidget_ReleaseCapture_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)views_bridge_mac::mojom::BridgedNativeWidget::ReleaseCapture",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool BridgedNativeWidgetRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "BridgedNativeWidget RequestValidator");

  switch (message->header()->name) {
    case internal::kBridgedNativeWidget_InitWindow_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_InitWindow_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_InitCompositorView_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_InitCompositorView_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_CreateContentView_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_CreateContentView_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_DestroyContentView_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_DestroyContentView_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_CloseWindow_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_CloseWindow_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_CloseWindowNow_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_CloseWindowNow_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_SetInitialBounds_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_SetInitialBounds_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_SetBounds_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_SetBounds_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_SetVisibilityState_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_SetVisibilityState_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_SetVisibleOnAllSpaces_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_SetVisibleOnAllSpaces_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_SetFullscreen_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_SetFullscreen_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_SetMiniaturized_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_SetMiniaturized_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_SetSizeConstraints_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_SetSizeConstraints_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_SetOpacity_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_SetOpacity_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_SetContentAspectRatio_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_SetContentAspectRatio_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_SetCALayerParams_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_SetCALayerParams_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_SetWindowTitle_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_SetWindowTitle_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_MakeFirstResponder_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_MakeFirstResponder_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_ClearTouchBar_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_ClearTouchBar_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_AcquireCapture_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_AcquireCapture_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kBridgedNativeWidget_ReleaseCapture_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::BridgedNativeWidget_ReleaseCapture_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

void BridgedNativeWidgetInterceptorForTesting::InitWindow(BridgedNativeWidgetInitParamsPtr params) {
  GetForwardingInterface()->InitWindow(std::move(params));
}
void BridgedNativeWidgetInterceptorForTesting::InitCompositorView() {
  GetForwardingInterface()->InitCompositorView();
}
void BridgedNativeWidgetInterceptorForTesting::CreateContentView(const gfx::Rect& bounds) {
  GetForwardingInterface()->CreateContentView(std::move(bounds));
}
void BridgedNativeWidgetInterceptorForTesting::DestroyContentView() {
  GetForwardingInterface()->DestroyContentView();
}
void BridgedNativeWidgetInterceptorForTesting::CloseWindow() {
  GetForwardingInterface()->CloseWindow();
}
void BridgedNativeWidgetInterceptorForTesting::CloseWindowNow() {
  GetForwardingInterface()->CloseWindowNow();
}
void BridgedNativeWidgetInterceptorForTesting::SetInitialBounds(const gfx::Rect& new_bounds, const gfx::Size& minimum_content_size, const gfx::Vector2d& parent_offset) {
  GetForwardingInterface()->SetInitialBounds(std::move(new_bounds), std::move(minimum_content_size), std::move(parent_offset));
}
void BridgedNativeWidgetInterceptorForTesting::SetBounds(const gfx::Rect& new_bounds, const gfx::Size& minimum_content_size) {
  GetForwardingInterface()->SetBounds(std::move(new_bounds), std::move(minimum_content_size));
}
void BridgedNativeWidgetInterceptorForTesting::SetVisibilityState(WindowVisibilityState new_state) {
  GetForwardingInterface()->SetVisibilityState(std::move(new_state));
}
void BridgedNativeWidgetInterceptorForTesting::SetVisibleOnAllSpaces(bool always_visible) {
  GetForwardingInterface()->SetVisibleOnAllSpaces(std::move(always_visible));
}
void BridgedNativeWidgetInterceptorForTesting::SetFullscreen(bool fullscreen) {
  GetForwardingInterface()->SetFullscreen(std::move(fullscreen));
}
void BridgedNativeWidgetInterceptorForTesting::SetMiniaturized(bool miniaturized) {
  GetForwardingInterface()->SetMiniaturized(std::move(miniaturized));
}
void BridgedNativeWidgetInterceptorForTesting::SetSizeConstraints(const gfx::Size& min_size, const gfx::Size& max_size, bool is_resizable, bool is_maximizable) {
  GetForwardingInterface()->SetSizeConstraints(std::move(min_size), std::move(max_size), std::move(is_resizable), std::move(is_maximizable));
}
void BridgedNativeWidgetInterceptorForTesting::SetOpacity(float opacity) {
  GetForwardingInterface()->SetOpacity(std::move(opacity));
}
void BridgedNativeWidgetInterceptorForTesting::SetContentAspectRatio(const gfx::SizeF& aspect_ratio) {
  GetForwardingInterface()->SetContentAspectRatio(std::move(aspect_ratio));
}
void BridgedNativeWidgetInterceptorForTesting::SetCALayerParams(const gfx::CALayerParams& ca_layer_params) {
  GetForwardingInterface()->SetCALayerParams(std::move(ca_layer_params));
}
void BridgedNativeWidgetInterceptorForTesting::SetWindowTitle(const base::string16& title) {
  GetForwardingInterface()->SetWindowTitle(std::move(title));
}
void BridgedNativeWidgetInterceptorForTesting::MakeFirstResponder() {
  GetForwardingInterface()->MakeFirstResponder();
}
void BridgedNativeWidgetInterceptorForTesting::ClearTouchBar() {
  GetForwardingInterface()->ClearTouchBar();
}
void BridgedNativeWidgetInterceptorForTesting::AcquireCapture() {
  GetForwardingInterface()->AcquireCapture();
}
void BridgedNativeWidgetInterceptorForTesting::ReleaseCapture() {
  GetForwardingInterface()->ReleaseCapture();
}
BridgedNativeWidgetAsyncWaiter::BridgedNativeWidgetAsyncWaiter(
    BridgedNativeWidget* proxy) : proxy_(proxy) {}

BridgedNativeWidgetAsyncWaiter::~BridgedNativeWidgetAsyncWaiter() = default;


}  // namespace mojom
}  // namespace views_bridge_mac

namespace mojo {


// static
bool StructTraits<::views_bridge_mac::mojom::BridgedNativeWidgetInitParams::DataView, ::views_bridge_mac::mojom::BridgedNativeWidgetInitParamsPtr>::Read(
    ::views_bridge_mac::mojom::BridgedNativeWidgetInitParams::DataView input,
    ::views_bridge_mac::mojom::BridgedNativeWidgetInitParamsPtr* output) {
  bool success = true;
  ::views_bridge_mac::mojom::BridgedNativeWidgetInitParamsPtr result(::views_bridge_mac::mojom::BridgedNativeWidgetInitParams::New());
  
      if (!input.ReadModalType(&result->modal_type))
        success = false;
      result->is_translucent = input.is_translucent();
      result->has_window_server_shadow = input.has_window_server_shadow();
      result->force_into_collection_cycle = input.force_into_collection_cycle();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif